clear
addpath(genpath('functions'))
rng(12345)
% Generate data (and compute MLE as option)
DGP_evmix=1;%=1 if mixture DGP =0 if logit DGP
if DGP_evmix==1
    run('functions/data_generation/gilleskie_gen_data_evmix.m');
    save('DATAgilleskie_gen_data_evmix.mat')
elseif DGP_evmix==0
    run('functions/data_generation/gilleskie_gen_data_logit.m');
    save('DATAgilleskie_gen_data_logit.mat')    
end
% if DGP_evmix==1
% load('DATAgilleskie_gen_data_evmix.mat')
% elseif DGP_evmix==0
% load('DATAgilleskie_gen_data_logit.mat')    
% end

% 3.(c) Chooises prior
% prior_W_mu    =[0.5 0.5];
% prior_W_s_comp=[0.5 0.5];
% prior_L_mu    =[0 0];
% prior_L_s_comp=[0 0];
% prior_S_mu    =[1 1  ];
% prior_S_s_comp=[1   1  ];
% prior_WEIGHT  =[ 0.5 0.5 ; prior_W_mu ; prior_W_s_comp ; 0.5  0.5  ; 0.5 0.5];
% prior_LOCATION=[ 0   0   ; prior_L_mu ; prior_L_s_comp ; 0    0    ; 0   0  ];
% prior_SCALE   =[ 1   1   ; prior_S_mu ; prior_S_s_comp ; 0.01 0.01 ; 3   3  ];

% Jan 20, 2022 larger scales 
prior_W_mu    =[0.5 0.5];
prior_W_s_comp=[0.5 0.5];
prior_L_mu    =[0 0];
prior_L_s_comp=[0 0];
prior_S_mu    =[2 2  ];
prior_S_s_comp=[1   1 ];
prior_WEIGHT  =[ 0.5 0.5 ; prior_W_mu ; prior_W_s_comp ; 0.5  0.5  ; 0.5 0.5];
prior_LOCATION=[ 0   0   ; prior_L_mu ; prior_L_s_comp ; 0    0    ; 0   0  ];
prior_SCALE   =[ 1   1   ; prior_S_mu ; prior_S_s_comp ; 0.01 0.01 ; 4   4  ];


% % Jan 20, 2022 even larger scales 
% prior_W_mu    =[0.5 0.5];
% prior_W_s_comp=[0.5 0.5];
% prior_L_mu    =[0 0];
% prior_L_s_comp=[0 0];
% prior_S_mu    =[3 3  ];
% prior_S_s_comp=[1   1 ];
% prior_WEIGHT  =[ 0.5 0.5 ; prior_W_mu ; prior_W_s_comp ; 0.5  0.5  ; 0.5 0.5];
% prior_LOCATION=[ 0   0   ; prior_L_mu ; prior_L_s_comp ; 0    0    ; 0   0  ];
% prior_SCALE   =[ 1   1   ; prior_S_mu ; prior_S_s_comp ; 0.01 0.01 ; 5  5  ];


% % The Rust prior
% prior_W_mu    =[0.5 0.5];
% prior_W_s_comp=[0.4 0.6];
% prior_L_mu    =[2 -3];%commented out Jan 19, 2022
% %prior_L_mu    =[0 -1];
% %prior_L_s_comp=[0   -3 ];%commented out Jan 19, 2022
% prior_L_s_comp=[0   -1 ];
% prior_S_mu    =[2   2  ]; %commented out Jan 19, 2022
% %prior_S_mu    =[1   1];
% prior_S_s_comp=[1   1  ]; 
% prior_WEIGHT  =[ 0.5 0.5 ; prior_W_mu ; prior_W_s_comp ; 0.5  0.5  ; 0.5 0.5];
% prior_LOCATION=[ 0   0   ; prior_L_mu ; prior_L_s_comp ; 0    0    ; 0   0  ];
% prior_SCALE   =[ 1   1   ; prior_S_mu ; prior_S_s_comp ; 0.01 0.01 ; 3   3  ];
% prior_SCALE   =[ 1   1   ; prior_S_mu ; prior_S_s_comp ; 0.01 0.01 ; 4   4  ];


%%%%%%%%%%%%%%%%%%
max_m=8;
Am_=0.05;
Amlogp_=5;

dir_hyp=10;
pi_m=exp(  -Am_.*(1:max_m).*(log(1:max_m).^Amlogp_)  );
pi_m/sum(pi_m) 


% ESTIMATION 

Npara_trans = (1:max_m)-1+J*(1:max_m)+(1:max_m)+1+S*include_u;
 
Nsim=10;                                         % Num of iterations per HMC 
Nmcmc_iter=100;20000;                             % Num of JDT outer-iterations 
m_sim=zeros(1,Nmcmc_iter);                       % Store m 
 
para_trans_sim=zeros(max_m-1+J*max_m+max_m+1+S*include_u,Nmcmc_iter);  % Store para_trans
 


% 3-1-2 Tune HMC para using the first data 
init_para_trans_specified=[];
parfor ind_m=1:max_m
smp_tuned_store{ind_m}=tune_hmc_given_m(ind_m,n_decision,init_para_trans_specified,prior_WEIGHT,prior_LOCATION,prior_SCALE,dir_hyp,...
    G,beta,u_fixed,Z_mat_Jp2toD,include_u);
fprintf('JUST TUNED for #%d\n', ind_m);

end 
% 3-1-3 Initialize m and para_trans
m_sim(1) = 2;
accept=zeros(Nmcmc_iter,1);
tic;
for mcmc_iter=2:Nmcmc_iter
mcmc_iter
% 1. Run HMC given m for Nsim draws    
temp=run_hmc_given_m(m_sim(mcmc_iter-1),n_decision,Nsim,smp_tuned_store,init_para_trans_specified,...
    prior_WEIGHT,prior_LOCATION,prior_SCALE,dir_hyp,...
    G,beta,u_fixed,Z_mat_Jp2toD,include_u)';

% 2. Run the block for m 
[m_sim(mcmc_iter),para_trans_sim(1:Npara_trans(m_sim(mcmc_iter)),mcmc_iter)]=run_jump_step(...
    temp(:,end),m_sim(mcmc_iter-1),...
    prior_WEIGHT,prior_LOCATION,prior_SCALE,dir_hyp,Am_,Amlogp_,...
    n_decision,J,K,G,beta,S,include_u,theta_fixed,u_fixed,Z_mat_Jp2toD,max_m);

init_para_trans_specified=para_trans_sim(1:Npara_trans(m_sim(mcmc_iter)),mcmc_iter);

accept(mcmc_iter)=(m_sim(mcmc_iter)~=m_sim(mcmc_iter-1));
   if mod(mcmc_iter,100)==1
   fprintf('JUST FINISHED ITERATION #%d\n', mcmc_iter);
   end
 
end 
toc; 
