
% 1. Normalization after estimation 
max_m=max(m_sim);Npara_trans = (1:max_m)-1+J*(1:max_m)+(1:max_m)+1+S*include_u;

% Prior of m
pi_m=exp(  -Am_.*(1:max_m).*(log(1:max_m).^Amlogp_)  );
% Posterior of m
t=tabulate(m_sim);
post_pmf=t(:,3)/100;
diff=length(pi_m)-length(post_pmf);
if diff~=0
    post_pmf=[post_pmf; zeros(diff,1)];
end 

% Parameters
s_sim=zeros(1,Nmcmc_iter);
omegamu_sim=zeros(J,Nmcmc_iter);
theta_sim=zeros(D,Nmcmc_iter);
ccp_array=zeros(K,4,Nmcmc_iter);
exp_d=zeros(4,Nmcmc_iter);
for mcmc_iter=2:Nmcmc_iter
[~,mu,~,~,theta_Jp2toD,omega,sigma,ccp]=compute_stats(para_trans_sim(1:Npara_trans(m_sim(mcmc_iter)),mcmc_iter),...
    theta_fixed,J,m_sim(mcmc_iter),K,S,include_u,u_fixed,Z_mat_Jp2toD,G,beta);

exp_d(:,mcmc_iter)=expected_decision(ccp,T,eta,H);
ccp_array(:,:,mcmc_iter)=ccp;                     

[s_sim(mcmc_iter),omegamu_sim(:,mcmc_iter)] =comp_s_omegamu_gilleskie(omega,mu , sigma );

theta_sim(1,mcmc_iter)= s_sim(mcmc_iter)* ( theta_fixed(1)+omegamu_sim(1,mcmc_iter) );
theta_sim(2,mcmc_iter)= s_sim(mcmc_iter)* ( theta_fixed(2)+omegamu_sim(2,mcmc_iter) );
theta_sim(3,mcmc_iter)= s_sim(mcmc_iter)* ( theta_fixed(3)+omegamu_sim(3,mcmc_iter) );
theta_sim(4,mcmc_iter)= 0;%-infty
theta_sim(5,mcmc_iter)= s_sim(mcmc_iter)*  theta_fixed(5);
theta_sim(6,mcmc_iter)= s_sim(mcmc_iter)* theta_Jp2toD;

    if mod(mcmc_iter,100) == 0
        fprintf('At iteration %d...\n',mcmc_iter);
    end

end 
 
% Inference for theta6
for mcmc_iter=1:Nmcmc_iter
para_trans=para_trans_sim(1:Npara_trans(m_sim(mcmc_iter)),mcmc_iter);
theta6_sim(mcmc_iter)=para_trans(end);
end 
mean_theta6=mean(theta6_sim);
LB_theta6=quantile(theta6_sim,0.025);
UB_theta6=quantile(theta6_sim,0.975);


% 2. Counterfactual 
% Counter-factual: Experiment 1 -> set PC=0
PC_cf=0;
prices_cf_exp1=[Y,PC_cf,L];

C0_cf_exp1=construct_Cd(0,T,prices_cf_exp1,phi);C1_cf_exp1=construct_Cd(1,T,prices_cf_exp1,phi);
C2_cf_exp1=construct_Cd(2,T,prices_cf_exp1,phi);C3_cf_exp1=construct_Cd(3,T,prices_cf_exp1,phi);
Z_1_Jp2toD_cf_exp1   = C1_cf_exp1.*[0;ones(K-1,1)];Z_2_Jp2toD_cf_exp1   = C2_cf_exp1.*[0;ones(K-1,1)];
Z_3_Jp2toD_cf_exp1   = C3_cf_exp1.*[0;ones(K-1,1)];Z_0_Jp2toD_cf_exp1   = C0_cf_exp1.*[0;ones(K-1,1)];
Z_mat_Jp2toD_cf_exp1=[Z_1_Jp2toD_cf_exp1;Z_2_Jp2toD_cf_exp1;Z_3_Jp2toD_cf_exp1;Z_0_Jp2toD_cf_exp1];
 
exp_d_cf_exp1=zeros(4,Nmcmc_iter);
ccp_cf_exp1_array=zeros(K,4,Nmcmc_iter);

parfor mcmc_iter=2:Nmcmc_iter
    
[~,~,~,~,~,~,~,ccp_cf_exp1]=...
    compute_stats(para_trans_sim(1:Npara_trans(m_sim(mcmc_iter)),mcmc_iter),...
    theta_fixed,J,m_sim(mcmc_iter),K,S,include_u,u_fixed,Z_mat_Jp2toD_cf_exp1,G,beta);
ccp_cf_exp1_array(:,:,mcmc_iter)=ccp_cf_exp1;   
exp_d_cf_exp1(:,mcmc_iter)=expected_decision(ccp_cf_exp1,T,eta,H);

mcmc_iter
end 

% Compute posterior E(v) and E(a)  
visit=exp_d(2,:) + exp_d(4,:);
mean_Ev=mean( visit );
LB_Ev=quantile(visit,0.025);
UB_Ev=quantile(visit,0.975);


% 1. Compute counterfactual E(v) and E(a), under Experiment 1
visit_cf_exp1=exp_d_cf_exp1(2,:) + exp_d_cf_exp1(4,:);
mean_Ev_cf_exp1=mean( visit_cf_exp1 );
LB_Ev_cf_exp1=quantile(visit_cf_exp1,0.025);
UB_Ev_cf_exp1=quantile(visit_cf_exp1,0.975);


% Compute HPD instead of quantile
Npts=1000;
[LB_theta6_HPD,UB_theta6_HPD]= comp_HPD(theta6_sim,Npts);
[LB_Ev_HPD,UB_Ev_HPD]= comp_HPD(visit,Npts);%[LB_Ev_HPD_2,UB_Ev_HPD_2]= comp_HPD(exp_d(2,:),Npts);[LB_Ev_HPD_4,UB_Ev_HPD_4]= comp_HPD(exp_d(4,:),Npts);LB_Ev_HPD_2+LB_Ev_HPD_4;UB_Ev_HPD_2+UB_Ev_HPD_4
[LB_Ev_cf_exp1_HPD,UB_Ev_cf_exp1_HPD]= comp_HPD(visit_cf_exp1,Npts);


% True values %
% Compute true Ev  
exp_d_true=expected_decision(ccp_true,T,eta,H);
Ev_true=exp_d_true(2) + exp_d_true(4);
% Compute true counterfactual Ev 
u1_cf_exp1_true=Z_1_1toJp1*theta_fixed+Z_1_Jp2toD_cf_exp1*theta6_dgp;
u2_cf_exp1_true=Z_2_1toJp1*theta_fixed+Z_2_Jp2toD_cf_exp1*theta6_dgp;
u3_cf_exp1_true=Z_3_1toJp1*theta_fixed+Z_3_Jp2toD_cf_exp1*theta6_dgp;
u0_cf_exp1_true=Z_0_1toJp1*theta_fixed+Z_0_Jp2toD_cf_exp1*theta6_dgp;
u_mat_cf_exp1_true=[u0_cf_exp1_true,u1_cf_exp1_true,u2_cf_exp1_true,u3_cf_exp1_true];
if DGP_evmix==0
[ccp_cf_exp1_true, ev_mat,v_mat,Q] = solveDP_dyn_logit(loc,scale,u_mat_cf_exp1_true,G,beta,100000);
elseif DGP_evmix==1 
[Q,v_mat,ev_mat,ccp_cf_exp1_true] = solveDP_evmix_NK(u_mat_cf_exp1_true,G,my_mu,my_sigma,my_omega,beta,1000,100000,zeros(K,1));
end 
exp_d_cf_exp1_true=expected_decision(ccp_cf_exp1_true,T,eta,H);
Ev_cf_exp1_true=exp_d_cf_exp1_true(2) + exp_d_cf_exp1_true(4);





% Compute the proposed robust credible intervals 
ccp_array_vec=reshape(ccp_array(:,1:J,:),K*J,Nmcmc_iter);
ccp_array_vec([1,K+1,2*K+1],:)=[];%Remove the ccp(x=1) because it's fixed (1,0,0,0).
bar_ccp=mean(ccp_array_vec,2);

Sigma_ccp=cov(ccp_array_vec');
% inv_Sigma_ccp=inv(Sigma_ccp);
% pinv_Sigma_ccp=pinv(Sigma_ccp);

apx_inv_Sigma_ccp=(Sigma_ccp+10^-10*eye(length(bar_ccp)))\eye(length(bar_ccp));%inv(Sigma_ccp);

chi_stat=zeros(Nmcmc_iter,1);
for mcmc_iter=2:Nmcmc_iter
dev=ccp_array_vec(:,mcmc_iter)-bar_ccp ;
chi_stat(mcmc_iter)=dev'*apx_inv_Sigma_ccp*dev;
end  
sum(0<chi_stat)
idx=(0<chi_stat & chi_stat<chi2inv(0.95,K*J));sum(idx)

LB_Ev_apx=min(visit(idx));
UB_Ev_apx=max(visit(idx));

LB_Ev_cf_exp1_apx=min(visit_cf_exp1(idx));
UB_Ev_cf_exp1_apx=max(visit_cf_exp1(idx));

% Ev
disp('E(v): EST       LB        UB      Length')
disp(Ev_true)
disp([mean_Ev_mle,LB_Ev_mle,UB_Ev_mle,UB_Ev_mle-LB_Ev_mle])
disp([mean(visit),LB_Ev_HPD,UB_Ev_HPD,UB_Ev_HPD-LB_Ev_HPD])
%disp([mean(visit),LB_Ev,UB_Ev,UB_Ev-LB_Ev])
disp([mean(visit),LB_Ev_apx,UB_Ev_apx,UB_Ev_apx-LB_Ev_apx])



% Ev cf 
disp('E(v)cf: EST       LB        UB      Length')
disp(Ev_cf_exp1_true)
disp([mean_Ev_mle_cf_exp1,LB_Ev_mle_cf_exp1,UB_Ev_mle_cf_exp1,UB_Ev_mle_cf_exp1-LB_Ev_mle_cf_exp1])
disp([mean(visit_cf_exp1),LB_Ev_cf_exp1_HPD,UB_Ev_cf_exp1_HPD,UB_Ev_cf_exp1_HPD-LB_Ev_cf_exp1_HPD])
%disp([mean(visit_cf_exp1),LB_Ev_cf_exp1,UB_Ev_cf_exp1,UB_Ev_cf_exp1-LB_Ev_cf_exp1])
disp([mean(visit_cf_exp1),LB_Ev_cf_exp1_apx,UB_Ev_cf_exp1_apx,UB_Ev_cf_exp1_apx-LB_Ev_cf_exp1_apx])




% 3. Plot the results 


% Plot posterior with confidence intervals 
figure
pts=0:0.01:5.5;%UB_Ev_cf_exp1_apx+0.1;
[f,xi] = ksdensity(visit,pts); 
f1=plot(xi,f,'LineWidth',6);hold on 
%f2=plot([mean_Ev_mle mean_Ev_mle],[0 1],'LineStyle',':','Color','red','LineWidth',3);hold on 
f3=plot([LB_Ev_mle LB_Ev_mle],[0 4],'LineStyle','--','Color','red','LineWidth',3);hold on 
f4=plot([UB_Ev_mle UB_Ev_mle],[0 4],'LineStyle','--','Color','red','LineWidth',3);hold on 
f5=plot([Ev_true Ev_true],[0 4],'LineStyle','-','Color','black','LineWidth',3);
f3=plot([LB_Ev_HPD LB_Ev_HPD],[0 4],'LineStyle',':','Color','blue','LineWidth',3);hold on 
f4=plot([UB_Ev_HPD UB_Ev_HPD],[0 4],'LineStyle',':','Color','blue','LineWidth',3);hold on 
f3=plot([LB_Ev_apx LB_Ev_apx],[0 4],'LineStyle','-.','Color','cyan','LineWidth',3);hold on 
f4=plot([UB_Ev_apx UB_Ev_apx],[0 4],'LineStyle','-.','Color','cyan','LineWidth',3);hold on 
xlabel('E(v)');%ylabel('\pi(E(v) | data )');
ylim([0 4]);xlim([0.5 UB_Ev_cf_exp1_apx+0.1]);xlim([0 5.5]);xticks([1 2 3 4 5])

set(gcf, 'PaperPosition', [0 0 6 5]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6 5]); %Set the paper to have width 5 and height 5.
set(gca,'fontsize',20)




figure
pts=0.01:0.01:6.5;%UB_Ev_cf_exp1_apx+0.1;
[f,xi] = ksdensity(visit_cf_exp1,pts); 
f1=plot(xi,f,'LineWidth',6);hold on 
%f2=plot([mean_Ev_mle_cf_exp1 mean_Ev_mle_cf_exp1],[0 1],'LineStyle',':','Color','red','LineWidth',3);hold on 
f3=plot([LB_Ev_mle_cf_exp1 LB_Ev_mle_cf_exp1],[0 4],'LineStyle','--','Color','red','LineWidth',3);hold on 
f4=plot([UB_Ev_mle_cf_exp1 UB_Ev_mle_cf_exp1],[0 4],'LineStyle','--','Color','red','LineWidth',3);hold on 
f5=plot([Ev_cf_exp1_true Ev_cf_exp1_true],[0 4],'LineStyle','-','Color','black','LineWidth',3);
f3=plot([LB_Ev_cf_exp1_HPD LB_Ev_cf_exp1_HPD],[0 4],'LineStyle',':','Color','blue','LineWidth',3);hold on 
f4=plot([UB_Ev_cf_exp1_HPD UB_Ev_cf_exp1_HPD],[0 4],'LineStyle',':','Color','blue','LineWidth',3);hold on 
f5=plot([LB_Ev_cf_exp1_apx LB_Ev_cf_exp1_apx],[0 4],'LineStyle',':','Color','cyan','LineWidth',3);hold on 
f6=plot([UB_Ev_cf_exp1_apx UB_Ev_cf_exp1_apx],[0 4],'LineStyle',':','Color','cyan','LineWidth',3);hold on 

xlabel('c.f. E(v)');%ylabel('\pi(c.f. E(v) | data )');
ylim([0 4]);xlim([0 6.5]);xticks([1 2 3 4 5])
set(gcf, 'PaperPosition', [0 0 6 5]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6 5]); %Set the paper to have width 5 and height 5.
set(gca,'fontsize',20)



% 1. Gilleskie_trace_m
figure
plot(1:Nmcmc_iter, m_sim,'.','MarkerSize',15);
set(gca,'YTick',unique(m_sim));
xlabel('iterations');ylabel('m')
ylim([0 max(m_sim)])
set(gcf, 'PaperPosition', [0 0 5 5]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [5 5]); %Set the paper to have width 5 and height 5.
set(gca,'fontsize',20)
xticks([0 Nmcmc_iter/2 Nmcmc_iter])


% 2. Gilleskie_pmf_m
figure
scatter(1:max_m,pi_m/sum(pi_m),300,'s' )
hold on
scatter(1:max_m,post_pmf,300,'o', 'MarkerFaceColor', 'r');ylim([0 0.4])
lgd=legend('prior','posterior','Location','northoutside', 'LineWidth', 0.5,'Orientation','horizontal');lgd.FontSize = 20; 

ylabel('Pr(m)');xlabel('m');ylim([0 0.4]);yticks([0 0.1 0.2 0.3 0.4])
xlim([0 max(m_sim)]);xticks(  unique(m_sim) )
set(gcf, 'PaperPosition', [0 0 5 5]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [5 5]); %Set the paper to have width 5 and height 5.
set(gca,'fontsize',20)



% 3. Gilleskie_trace
figure
subplot(2,2,1); plot(1:Nmcmc_iter,omegamu_sim(1,:));title('\omega^T \mu_1');xlabel('iterations');xticks([0 Nmcmc_iter/2 Nmcmc_iter]);set(gca,'fontsize',20);set(gcf, 'PaperPosition', [0 0 15 10]); set(gcf, 'PaperSize', [15 10]); 
subplot(2,2,2); plot(1:Nmcmc_iter,omegamu_sim(2,:));title('\omega^T \mu_2');xlabel('iterations');xticks([0 Nmcmc_iter/2 Nmcmc_iter]);set(gca,'fontsize',20);set(gcf, 'PaperPosition', [0 0 15 10]); set(gcf, 'PaperSize', [15 10]); 
subplot(2,2,3); plot(1:Nmcmc_iter,omegamu_sim(3,:));title('\omega^T \mu_3');xlabel('iterations');xticks([0 Nmcmc_iter/2 Nmcmc_iter]);set(gca,'fontsize',20);set(gcf, 'PaperPosition', [0 0 15 10]); set(gcf, 'PaperSize', [15 10]); 
subplot(2,2,4); plot(1:Nmcmc_iter,s_sim);title('s');ylim([0 3]);xlabel('iterations');xticks([0 Nmcmc_iter/2 Nmcmc_iter]);set(gca,'fontsize',20);set(gcf, 'PaperPosition', [0 0 15 10]); set(gcf, 'PaperSize', [15 10]); 


% 4. Gilleskie_trace_theta
figure
for p=1:6
    if p~=4
subplot(2,3,p);plot(theta_sim(p,:)); title(['\theta_' num2str(p) ]);xlabel('iterations');xticks([0 Nmcmc_iter/2 Nmcmc_iter])%ylim([0 25]); %xlim([0 5*10^6 ])  
    end 
set(gca,'fontsize',20);  
set(gcf, 'PaperPosition', [0 0 15 10]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [15 10]); %Set the paper to have width 5 and height 5.
    
end 
theta_dgp=[theta_fixed(1:5);theta6_dgp];


% 5. Gilleskie_posterior_theta
slice=1;
theta_sim_sliced=theta_sim(:,1:slice:end);
figure

UBset=[1.2 1.2 0.7 NaN 1.5  50];
bw_set=[0.5 0.3 0.3 NaN 0.3 0.01];
LB_set_x=[-4 -3 -7 NaN -0.5 -0.05];
UB_set_x=[1.5 2.2 0.5 NaN 2.5 0.07];
for p=1:6
if p~=4
    subplot(2,3,p)
[f,xi] = ksdensity(theta_sim_sliced(p,:),'Bandwidth',bw_set(p)); plot(xi,f,'LineWidth',10);
title(['\theta_' num2str(p) ]);%ylim([0 25]); %xlim([0 5*10^6 ])  
hold on 
line([theta_dgp(p) theta_dgp(p)], [0 UBset(p)],'LineStyle','--','Color','black'); 
ylim([0 UBset(p)])
xlim([LB_set_x(p) UB_set_x(p) ] )
end 
set(gca,'fontsize',20)

set(gcf, 'PaperPosition', [0 0 15 10]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [15 10]); %Set the paper to have width 5 and height 5.

end 



 










