% g: theta -> Ev
% f: theta -> Ea

function [Ev, Ea]=comp_ev_ea_mle(theta_mle,hessian,cf_flag,...
                            theta4_fixed,theta5_fixed,...
                            Z_1_1toJp1,Z_2_1toJp1,Z_3_1toJp1,Z_0_1toJp1,PC,Y,L,phi,K,T,eta,H,G,beta);


h=0.1;%0.1;0.5;0.1;%larger value leads to narrower CI
Ngrid=1;
Npts=2*Ngrid+1;
grid=zeros(4,Npts);
for k=1:4
grid_right=theta_mle(k)          :h:(theta_mle(k)+h*Ngrid);
grid_left=(theta_mle(k)-h*Ngrid) :h:theta_mle(k);
grid(k,:)=[grid_left(1:end-1),grid_right];
end 

Ev_mle_mat=zeros(Npts,Npts,Npts,Npts);
Ea_mle_mat=zeros(Npts,Npts,Npts,Npts);
for j1=1:Npts
    for j2=1:Npts
        for j3=1:Npts
            for j4=1:Npts
                theta=[grid(1,j1),grid(2,j2),grid(3,j3),grid(4,j4)];
                [Ev_mle_mat(j1,j2,j3,j4),Ea_mle_mat(j1,j2,j3,j4)]=...
                    ed_mle(theta,cf_flag,theta4_fixed,theta5_fixed,...
                            Z_1_1toJp1,Z_2_1toJp1,Z_3_1toJp1,Z_0_1toJp1,PC,Y,L,phi,K,T,eta,H,G,beta);
            end 
        end 
    end 
end     
% par g / par theta_j j=1:4
[grad_g_theta1,grad_g_theta2,grad_g_theta3,grad_g_theta4]=gradient(Ev_mle_mat,h);
% par f / par theta_j j=1:4
[grad_f_theta1,grad_f_theta2,grad_f_theta3,grad_f_theta4]=gradient(Ea_mle_mat,h);


ind = find( (grid(1,:) == theta_mle(1)) & (grid(2,:) == theta_mle(2))& (grid(3,:) == theta_mle(3))& (grid(4,:) == theta_mle(4))  );
% grad_g_theta_mle=[grad_g_theta1(ind),grad_g_theta2(ind),grad_g_theta3(ind),grad_g_theta4(ind)]';% Gradient of g at mle
% grad_f_theta_mle=[grad_f_theta1(ind),grad_f_theta2(ind),grad_f_theta3(ind),grad_f_theta4(ind)]';% Gradient of f at mle

grad_g_theta_mle=[grad_g_theta1(ind,ind,ind,ind),grad_g_theta2(ind,ind,ind,ind),grad_g_theta3(ind,ind,ind,ind),grad_g_theta4(ind,ind,ind,ind)]';% Gradient of g at mle
grad_f_theta_mle=[grad_f_theta1(ind,ind,ind,ind),grad_f_theta2(ind,ind,ind,ind),grad_f_theta3(ind,ind,ind,ind),grad_f_theta4(ind,ind,ind,ind)]';% Gradient of f at mle

% For E(v)
Est_Asy_Var_g_theta_mle=grad_g_theta_mle'*inv(hessian)*grad_g_theta_mle;
Est_Asy_Var_g_theta_mle=grad_g_theta_mle'*inv(diag(diag(hessian)))*grad_g_theta_mle;

se_g_theta_mle=sqrt(Est_Asy_Var_g_theta_mle);

g_theta_mle=Ev_mle_mat(ind,ind,ind,ind);
UB_g_theta_mle=g_theta_mle+1.96*se_g_theta_mle;
LB_g_theta_mle=g_theta_mle-1.96*se_g_theta_mle;

Ev_mle=g_theta_mle;
UB_Ev_mle=UB_g_theta_mle;
LB_Ev_mle=LB_g_theta_mle;

Ev=[LB_Ev_mle,Ev_mle,UB_Ev_mle];

% For E(a)
Est_Asy_Var_f_theta_mle=grad_f_theta_mle'*inv(hessian)*grad_f_theta_mle;
se_f_theta_mle=sqrt(Est_Asy_Var_f_theta_mle);

f_theta_mle=Ea_mle_mat(ind,ind,ind,ind);
UB_f_theta_mle=f_theta_mle+1.96*se_f_theta_mle;
LB_f_theta_mle=f_theta_mle-1.96*se_f_theta_mle;

Ea_mle=f_theta_mle;
UB_Ea_mle=UB_f_theta_mle;
LB_Ea_mle=LB_f_theta_mle;

Ea=[LB_Ea_mle,Ea_mle,UB_Ea_mle];

end 











