function[grad_Q_omega,grad_Q_mu,grad_Q_sigma,grad_Q_u0,grad_Q_ud]...
=comp_ift_Q_new(omega,mu,sigma,a,A,ccp,ccp_mixcomp,v_mat,beta,G)

%ccp=ccp+0.0000000001;% Jan 19, 2022

[m,K]=size(A);J=size(mu,1);Nd=J+1;

if beta==0
grad_Q_omega   =zeros(K,m-1);
grad_Q_mu      =zeros(K,m*J);
grad_Q_sigma   =zeros(K,m);
grad_Q_u0      =zeros(K,K);
grad_Q_ud      =zeros(K,K*J);
else 
   
% 1. grad_f_Q    
newG=reshape( G', K,K,Nd);
newP=reshape(kron(ccp,ones(K,1)),K,K,Nd);
grad_f_Q =eye(K)-beta*sum(newP.*newG,3)'  ;
inv_g_f_Q= grad_f_Q\eye(K);  %same as inv_g_f_Q= inv(grad_f_Q);
 
if m>1
% 2. grad_f_omega 
grad_f_omega=...
-sigma(1:m-1)'.*( A(1:(m-1),:)' + modify_expint_exp_minus( a(1:(m-1),:)' ) )...
+repmat( sigma(m).*( A(m,:)' + modify_expint_exp_minus(a(m,:)') ), 1,m-1);
end 

% 3. grad_f_mu
new_mix = reshape(ccp_mixcomp(K+1:end,:)',m,K,J   );
new_omega=reshape(repmat(omega',K*J,1)',m,K,J);
mat=new_omega.*new_mix;
grad_f_mu=-reshape(permute(mat,[2,1,3]),size(mat,2),[]);

% 4. grad_f_sigma
part1=- omega'.*(A'+ modify_expint_exp_minus(a') );

new_v_mat=reshape(kron(reshape(v_mat,K*Nd,1),ones(1,m))',m,K,Nd);
mu_mat=[zeros(1,m);mu];
new_mu_mat=reshape( kron(mu_mat,ones(K,1))', m,K,Nd);
new_sigma_mat=reshape(repmat(sigma',K*Nd,1)',m,K,Nd);
z_mat = (new_v_mat+new_mu_mat)./new_sigma_mat;
newPmix=reshape(ccp_mixcomp',m,K,Nd);
part2= omega'.*sum(newPmix.*z_mat,3)';
grad_f_sigma=part1+part2;

% 5. grad_f_u0
grad_f_u0 = -diag( ccp(:,1) );
% 6. grad_f_ud 
res=reshape(kron(ccp(:,2:end),ones(1,K)),K,K,J)...
.*reshape(repmat(eye(K),J,1)',K,K,J);
grad_f_ud = -reshape(permute(res,[2,1,3]),size(res,2),[]);

% IFT
if m>1
grad_Q_omega  =-inv_g_f_Q*grad_f_omega;
elseif m==1
grad_Q_omega=[];   
end 
grad_Q_mu     =-inv_g_f_Q*grad_f_mu;
grad_Q_sigma  =-inv_g_f_Q*grad_f_sigma;
grad_Q_u0     =-inv_g_f_Q*grad_f_u0;
grad_Q_ud     =-inv_g_f_Q*grad_f_ud;

% Modification for likelihood evaluation 
ind_mu=reshape((repmat(1:m:1+(J-1)*m,m,1)+[0:1:m-1]')',1,J*m);
ind_ud=reshape((repmat(1:K:1+(J-1)*K,K,1)+[0:1:K-1]')',1,J*K);

grad_Q_mu=grad_Q_mu(:,ind_mu);
grad_Q_ud=grad_Q_ud(:,ind_ud);


end 













