% Input 1: theta=theta1,2,3,6 (utility para) 
% Input 2: n_decision, G, beta, 
% theta_fixed,
% Z_j_1toJp1,  j=0,1,2,3
% Z_j_Jp2toD,  j=0,1,2,3
% Conpute -loglikelihood as a function of theta6 
% assuming e0,e1,e2,e3 are iid EV(0,1) as in Gilleskie 
function loglik= comp_loglike_gilleskie(theta,theta4_fixed,theta5_fixed,n_decision, G, beta,...
    Z_1_1toJp1,Z_2_1toJp1,Z_3_1toJp1,Z_0_1toJp1,...
    Z_1_Jp2toD,Z_2_Jp2toD,Z_3_Jp2toD,Z_0_Jp2toD)

theta1=theta(1);
theta2=theta(2);
theta3=theta(3);
theta6=theta(4);

theta_fixed=[theta1 theta2 theta3 theta4_fixed theta5_fixed]';


% 1. Create u_mat
u1=Z_1_1toJp1*theta_fixed+Z_1_Jp2toD*theta6;
u2=Z_2_1toJp1*theta_fixed+Z_2_Jp2toD*theta6;
u3=Z_3_1toJp1*theta_fixed+Z_3_Jp2toD*theta6;
u0=Z_0_1toJp1*theta_fixed+Z_0_Jp2toD*theta6;
u_mat=[u0,u1,u2,u3];
% 2. Compute CCP
ccp = solveDP_dyn_logit(0,1,u_mat,G,beta,100000);
% 3. Compute loglikelihood 
loglik = -sum( sum( n_decision(2:end,:).*log(ccp(2:end,:)) ) );
end 


