% 1. Def
% m = 1,2,3,...
% chi_{1:m} = para_trans_unnor
%
% map =  argmax_{ chi_{m+1}  } posterior of chi_{m+1} given the value of chi_{1:m} fixed        
%
% 2. Inputs
% chi_{1:m} = (gamma_{1:m}, mu_{1:J,1:m}, s_comp_{1:m}, s_common, theta's) 
%                  (m + m*J + m + 1 + S) by 1  
%
% 3. Outputs
% map  = (gamma_{m+1}, mu_{1:J,m+1}, s_comp_{m+1} ), (J+2) by 1 
%
% cov  =  the cov matrix (J+2) by (J+2) 

function [map,hessian] = comp_map_cov_mp1(para_trans_unnor,...
prior_WEIGHT,prior_LOCATION,prior_SCALE,dir_hyp,...
    m,G,beta,u_fixed,Z_mat_Jp2toD,n_decision,include_u,Q_init)
% 1. Set initial value 
[K,Nd]=size(n_decision);J=Nd-1;S=size(Z_mat_Jp2toD,2);
Ngamma          = m;
Nmu_vec         = J*m;
Ns_comp         = m;
Ns_common       = 1;
Ntheta_Jp2toD   = S;
N1              = Ngamma;
N2              = Ngamma+Nmu_vec;
N3              = Ngamma+Nmu_vec+Ns_comp;
N4              = Ngamma+Nmu_vec+Ns_comp+Ns_common;
N5              = Ngamma+Nmu_vec+Ns_comp+Ns_common+Ntheta_Jp2toD;
gamma           = para_trans_unnor(1:N1);
mu_vec          = para_trans_unnor(1+N1:N2);
s_comp          = para_trans_unnor(1+N2:N3);
s_common        = para_trans_unnor(1+N3:N4);
if include_u==1
theta_Jp2toD    = para_trans_unnor(1+N4:N5);
end 
mu=reshape(mu_vec',m,J)';

init=[mean(gamma);0 ;0; 0; 0];% modified 11/8/2019 (we have thrww more mu and 1 more sigma)
init=[mean(gamma);randn ;randn; randn; randn];% modified 5/2/2022 


%init=[mean(gamma);0+0.1*rand;0+0.1*rand];%8/21 (this block hasnt passed JDT)


options = optimoptions('fmincon','Display','off','SpecifyObjectiveGradient',true,...
    'StepTolerance',10^-2);%,'FunValCheck','on');%'MaxFunctionEvaluations',1000);
options = optimoptions('fmincon','Display','off','SpecifyObjectiveGradient',false,...
    'StepTolerance',10^-1);
% para_trans_unnor_mp1 = (alpha_{m}, mu_{j,m+1} j=1:J, s_comp_{m+1} ), (J+2) by 1 
fun = @(para_trans_unnor_mp1)comp_logpost_mp1(para_trans_unnor_mp1,para_trans_unnor,m,n_decision,...
    prior_WEIGHT,prior_LOCATION,prior_SCALE,dir_hyp,...
    G,beta,u_fixed,Z_mat_Jp2toD,include_u,Q_init);
A = [];b = [];Aeq = [];beq = [];lb = [0.001;-Inf(J+1,1)];ub = Inf(J+2,1);nonlcon = [];
%A = [];b = [];Aeq = [];beq = [];lb = [0.1;-Inf(J+1,1)];ub = Inf(J+2,1);nonlcon = [];%8/21/2019 (this block hasnt passed JDT)


[map,~,~,~,~,grad,hessian] = fmincon(fun,init,A,b,Aeq,beq,lb,ub,nonlcon,options);
% Done minimization - > hessian is PSD 
% 

%{
alpha_m_map = map(1);
mu_mp1_map = map(2:end-1);
s_comp_mp1_map =map(end);

% 3. Combine 
alpha_new=[alpha;alpha_m_map];
mu_new=[mu,mu_mp1_map];
mu_vec_new=reshape(mu_new',(m+1)*J,1);
s_comp_new=[s_comp;s_comp_mp1_map];
%
para_trans_new=[ alpha_new ;mu_vec_new;s_comp_new;s_common; theta_Jp2toD   ];

[grad2_post_alpha,grad2_post_mu,grad2_post_s_comp]=...
    comp_2nd_deriv(para_trans_new,G,m+1,n_decision,include_u,Z_mat_Jp2toD,u_fixed,beta,...
    prior_WEIGHT,prior_LOCATION,prior_SCALE);

grad2_post_mu_vec=reshape(grad2_post_mu',m+1,J)';

hess=diag( [grad2_post_alpha(end); grad2_post_mu_vec(:,end);grad2_post_s_comp(end)] );

cov=-inv(hess);
%}

%cov=inv(hessian);
end 



