% Input: para_trans -- a column vector 
% Output: 
% 1. omega, mu, sigma, sigma_all, theta_Jp2toD
% 2. s, omegamu 
% 3. theta's for utility 
% 4. ccp
function  [alpha,mu,s_comp,s_common,theta_Jp2toD,omega,sigma,ccp]=...
    compute_stats(para_trans,theta_fixed,J,m,K,S,include_u,u_fixed,Z_mat_Jp2toD,G,beta)
% 1. Unpack the para_trans 
Nalpha        = m-1;
Nmu_vec       = J*m;
Ns_comp       = m;
Ns_common     = 1;
Ntheta_Jp2toD = S;
N1            = Nalpha;
N2            = Nalpha+Nmu_vec;
N3            = Nalpha+Nmu_vec+Ns_comp;
N4            = Nalpha+Nmu_vec+Ns_comp+Ns_common;
N5            = Nalpha+Nmu_vec+Ns_comp+Ns_common+Ntheta_Jp2toD;

if m>1
alpha         = para_trans(1:N1);
else
alpha=[];
end 
mu_vec        = para_trans(1+N1:N2);mu=reshape(mu_vec,m,J)';
s_comp        = para_trans(1+N2:N3);
s_common      = para_trans(1+N3:N4);
if include_u==1
theta_Jp2toD  = para_trans(1+N4:N5);
else 
theta_Jp2toD=[];    
end 



para=trans_inv_var(para_trans,m,J,S,include_u);
Nomega        = m;
Nmu_vec       = J*m;
Nsigma        = m;
Nsigma_common = 1;
Ntheta_Jp2toD = S;
N1            = Nomega;
N2            = Nomega+Nmu_vec;
N3            = Nomega+Nmu_vec+Nsigma;
N4            = Nomega+Nmu_vec+Nsigma+Nsigma_common;
N5            = Nomega+Nmu_vec+Nsigma+Nsigma_common+Ntheta_Jp2toD;
omega         = para(1:N1);
%mu_vec        = para(1+N1:N2);mu=reshape(mu_vec,m,J)';
sigma         = para(1+N2:N3);
 

if nargout==8 %if you need ccp 



% Define u_mat 
if J>1 && include_u==1
    
Z_1_Jp2toD=Z_mat_Jp2toD(1:K);
Z_2_Jp2toD=Z_mat_Jp2toD(K+1:2*K);
Z_3_Jp2toD=Z_mat_Jp2toD(2*K+1:3*K);
Z_0_Jp2toD=Z_mat_Jp2toD(3*K+1:4*K);

Z_1_1toJp1   = [ones(K,1),     zeros(K,1),   zeros(K,1)      [1;zeros(K-1,1)] ,zeros(K,1) ];
Z_2_1toJp1   = [zeros(K,1),    ones(K,1),    zeros(K,1)      [1;zeros(K-1,1)] ,zeros(K,1) ];
Z_3_1toJp1   = [zeros(K,1),    zeros(K,1),   ones(K,1)       [1;zeros(K-1,1)] ,zeros(K,1) ];
Z_0_1toJp1   = [zeros(K,1),    zeros(K,1),   zeros(K,1)      zeros(K,1),      [1;zeros(K-1,1)]  ];
 
u1=Z_1_1toJp1*theta_fixed+Z_1_Jp2toD*theta_Jp2toD;% For Gilleskie, 11/8/19
u2=Z_2_1toJp1*theta_fixed+Z_2_Jp2toD*theta_Jp2toD;
u3=Z_3_1toJp1*theta_fixed+Z_3_Jp2toD*theta_Jp2toD;
u0=Z_0_1toJp1*theta_fixed+Z_0_Jp2toD*theta_Jp2toD;
u_mat=[u0,u1,u2,u3];
    

elseif J==1 && include_u==0
    u1 = theta_fixed(1) + theta_fixed(2)*(1:K)'; 
    u0 = zeros(K,1);
    u_mat=[u0,u1];
end 

[~,~,~,ccp] = solveDP_evmix_NK(u_mat,G,mu,sigma,omega,beta,50,100000,zeros(K,1)) ;

end 

end 
