%clear
addpath(genpath('functions'))

J=3;S=1;include_u=1;

m=2;
DGP_para_trans=[0.22837,-0.4683, 0.9798, 3.4628, -2.2437, -0.0914, 1.3496, 1.3094, -0.449, 0, 0.0469];

my_para=trans_inv_var(DGP_para_trans,m,J,S,include_u);
% Start: From compute_stats.m
Nomega        = m;
Nmu_vec       = J*m;
Nsigma        = m;
Nsigma_common = 1;
Ntheta_Jp2toD = S;
N1            = Nomega;
N2            = Nomega+Nmu_vec;
N3            = Nomega+Nmu_vec+Nsigma;
N4            = Nomega+Nmu_vec+Nsigma+Nsigma_common;
N5            = Nomega+Nmu_vec+Nsigma+Nsigma_common+Ntheta_Jp2toD;
% End: From compute_stats.m 
my_omega         = my_para(1:N1);
my_mu_vec        = my_para(1+N1:N2);my_mu=reshape(my_mu_vec,m,J)';
my_sigma         = my_para(1+N2:N3);
my_sigma_common  = my_para(1+N3:N4);
my_theta_Jp2toD  = my_para(1+N4:N5);

beta=0.9997;
J=3;
T=8;
K=1+sum( (1:1:T).^2 );
 
% Demographic information for pi_s & pi_w
H=zeros(3,1);
H(1)=0; % 1 if good health
H(2)=1; % 1 if fair/poor health
H(3)=1; % 1 if 45-64 age 
 
% Para for pi_s
delta01=-6.6;delta11=0.03;delta21=-0.17;delta31=-0.45;
delta02=-17;delta12=4.7;delta22=-0.13;delta32=-0.37;
delta=[delta01,delta11,delta21,delta31]';
 
% Para for pi_w
eta0=-6.8;
eta1=-0.2;
eta2=0.07;
eta3=-2.6;
eta4=1.75;
eta5=0.06;
eta6=0.5;eta7=-0.049;eta8=0.001;
eta9=-0.3;eta10=-0.02;eta11=-0.28;
eta=[eta0,eta1,eta2,eta3,eta4,eta5,eta6,eta7,eta8,eta9,eta10,eta11]';

% Transition matrices 
G0=construct_Gd(0,T,eta,delta,H);
G1=construct_Gd(1,T,eta,delta,H);
G2=construct_Gd(2,T,eta,delta,H);
G3=construct_Gd(3,T,eta,delta,H);
G=[G0;G1;G2;G3];
 
% Consumptions
Y=100;PC=15;
L=0.7;

phi1=5.6;phi2=-1.75;
phi=[phi1,phi2];prices=[Y,PC,L];
 
C0=construct_Cd(0,T,prices,phi);
C1=construct_Cd(1,T,prices,phi);
C2=construct_Cd(2,T,prices,phi);
C3=construct_Cd(3,T,prices,phi);
 
Z_1_1toJp1   = [ones(K,1),     zeros(K,1),   zeros(K,1)      [1;zeros(K-1,1)] ,zeros(K,1) ];
Z_2_1toJp1   = [zeros(K,1),    ones(K,1),    zeros(K,1)      [1;zeros(K-1,1)] ,zeros(K,1) ];
Z_3_1toJp1   = [zeros(K,1),    zeros(K,1),   ones(K,1)       [1;zeros(K-1,1)] ,zeros(K,1) ];
Z_0_1toJp1   = [zeros(K,1),    zeros(K,1),   zeros(K,1)      zeros(K,1),      [1;zeros(K-1,1)]  ];
Z_mat_1toJp1=[Z_1_1toJp1;Z_2_1toJp1;Z_3_1toJp1;Z_0_1toJp1];
 
alpha1=-125;
alpha2=83;
 
rho=100;
theta1_fixed=alpha1/rho;
theta2_fixed=-alpha2/rho;
theta3_fixed=(alpha1-alpha2)/rho;
theta4_fixed=-10000;
theta5_fixed=Y/rho;
 
theta_fixed=[theta1_fixed theta2_fixed theta3_fixed theta4_fixed theta5_fixed]';
u_fixed=Z_mat_1toJp1*theta_fixed;
 
% The parameter part
include_u=1;D=6;S=1;
 
Z_1_Jp2toD   = C1.*[0;ones(K-1,1)];
Z_2_Jp2toD   = C2.*[0;ones(K-1,1)];
Z_3_Jp2toD   = C3.*[0;ones(K-1,1)];
Z_0_Jp2toD   = C0.*[0;ones(K-1,1)];
Z_mat_Jp2toD=[Z_1_Jp2toD;Z_2_Jp2toD;Z_3_Jp2toD;Z_0_Jp2toD];
 
% 1. (d) Generate the Sufficient statistics (i.e. data) using the true CCP and a large "N"
theta6_dgp =my_theta_Jp2toD;
my_u1=Z_1_1toJp1*theta_fixed+Z_1_Jp2toD*my_theta_Jp2toD;
my_u2=Z_2_1toJp1*theta_fixed+Z_2_Jp2toD*my_theta_Jp2toD;
my_u3=Z_3_1toJp1*theta_fixed+Z_3_Jp2toD*my_theta_Jp2toD;
my_u0=Z_0_1toJp1*theta_fixed+Z_0_Jp2toD*my_theta_Jp2toD;
 
my_u_mat_dgp=[my_u0,my_u1,my_u2,my_u3];
loc=0;
scale=1;

[Q,v_mat,ev_mat,ccp_true] = solveDP_evmix_NK(my_u_mat_dgp,G,my_mu,my_sigma,my_omega,beta,1000,100000,zeros(K,1));

N=100;
n_decision=gen_data_seq_gilleskie(N,T,G0,G1,G2,G3,ccp_true);


% Optional: compute MLE
run('Gilleskie_MLE.m')







