% g: theta -> e(v) and e(a)
% Input: theta_mle, 
%        theta4_fixed,theta5_fixed
% Output: Ev, Ea

% cf_flag=1 if Experiment 1
% cf_flag=2 if Experiment 2
% cf_flag=0 if original 



function [Ev_mle, Ea_mle]=ed_mle(theta_mle,cf_flag,...
    theta4_fixed,theta5_fixed,...
    Z_1_1toJp1,Z_2_1toJp1,Z_3_1toJp1,Z_0_1toJp1,PC,Y,L,phi,K,T,eta,H,G,beta)

theta1_mle=theta_mle(1);
theta2_mle=theta_mle(2);
theta3_mle=theta_mle(3);
theta6_mle=theta_mle(4);
theta_fixed=[theta1_mle theta2_mle theta3_mle theta4_fixed theta5_fixed]';



% Counter-factual 
PC_cf=0;L_cf=L;

if cf_flag==1
prices=[Y,PC_cf,L];
elseif cf_flag==2
prices=[Y,PC_cf,L_cf];
elseif cf_flag==0
prices=[Y,PC,L];
end 
C0=construct_Cd(0,T,prices,phi);
C1=construct_Cd(1,T,prices,phi);
C2=construct_Cd(2,T,prices,phi);
C3=construct_Cd(3,T,prices,phi);
Z_1_Jp2toD   = C1.*[0;ones(K-1,1)];
Z_2_Jp2toD   = C2.*[0;ones(K-1,1)];
Z_3_Jp2toD   = C3.*[0;ones(K-1,1)];
Z_0_Jp2toD   = C0.*[0;ones(K-1,1)];

% 2. counterfactual 
u1_mle=Z_1_1toJp1*theta_fixed+Z_1_Jp2toD*theta6_mle;
u2_mle=Z_2_1toJp1*theta_fixed+Z_2_Jp2toD*theta6_mle;
u3_mle=Z_3_1toJp1*theta_fixed+Z_3_Jp2toD*theta6_mle;
u0_mle=Z_0_1toJp1*theta_fixed+Z_0_Jp2toD*theta6_mle;
u_mat_mle=[u0_mle,u1_mle,u2_mle,u3_mle];

[ccp_mle, ~,~,~] = solveDP_dyn_logit(0,1,u_mat_mle,G,beta,100000);
exp_d_mle=expected_decision(ccp_mle,T,eta,H);

% Doctor visits
Ev_mle= exp_d_mle(2,:) + exp_d_mle(4,:) ;
% Absences
Ea_mle= exp_d_mle(3,:) + exp_d_mle(4,:) ;

end 
 