% b can be a matrix 
% This is to prevent expint(exp(-b)) = NaN or Inf
function val = modify_expint_exp_minus(b)

ind_1=(exp(-b)==Inf);% this b will lead to expint(exp(-b)) = NaN
ind_2=(exp(-b)==0);  % this b will lead to expint(exp(-b)) = Inf

val=expint(exp(-b));
%case1=zeros(size(b,1),size(b,2)); 
case2=b.*exp(-exp(-b))-double(eulergamma);

val(ind_1)=0;            % Replace expint(exp(-b)) = NaN with 0
val(ind_2)=case2(ind_2); % Replace expint(exp(-b)) = Inf with b.*exp(-exp(-b))-double(eulergamma)
end

% Rmk 1: Equivalent to the following

%if     exp(-b)==Inf
% val = 0;   
%elseif exp(-b)==0
% val = b*exp(-exp(-b))-double(eulergamma);
%else
% val = expint(exp(-b));   
%end 

% Rmk 2: Check graphically  
%clear
%grid_a = -1000:1:1000;
%f_a = expint(exp(-grid_a));
%g_a = modify_expint_exp_minus_b(grid_a);

%figure
%subplot(1,2,1)
%plot(grid_a,f_a,  'Color', 'r', 'LineWidth', 3)
%title('expint(exp(-a))')
%xlabel('a')
%xlim([-1000 1000])

%subplot(1,2,2)
%plot(grid_a,g_a,  'Color', 'r', 'LineWidth', 3)
%title('modified')
%xlabel('a')
%xlim([-1000 1000])







