% Computes the cdf for F for the EV mixture 
% where F = sum_k omega_k * EV(mu_k,sigma_k)
% mu is J by m 
% omega is m by 1
% sigma is m by 1
% x is a column vector  


function cdf = cdf_evmix(omega, mu, sigma, x)
J=size(mu,1);m=length(omega);Nx=length(x);

if J==1
z= (x-mu)'./sigma;
t = exp( - z  - double(eulergamma));
cdf = omega'*exp( -t ) ;
else
t=zeros(m,Nx,J);   
    for d=1:J    
    z= (x(d)-mu(d,:))'./sigma;
    t(:,:,d) = exp( - z  - double(eulergamma));
    end
cdf=  omega'*( exp(t(:,:,1)).*exp(t(:,:,2)) ) ;    
end 
end 
