% Given a vector x_sim produced by MCMC, compute HPD credible interval
% We assume unimodality 

% Npts is the num of grid points 
function [LB_x_HPD,UB_x_HPD]= comp_HPD(x_sim,Npts)
min_x=min(x_sim);
max_x=max(x_sim);
del=(max_x-min_x)/(Npts-1);
grid_x=min_x:del:max_x;


[f,xi] = ksdensity(x_sim,grid_x); 
%figure;plot(xi,f);
f=f/sum(f);
mat=[grid_x',f'];
mat_sorted=sortrows(mat,2 ,'descend');
mat_sorted=[mat_sorted,cumsum(mat_sorted(:,2))];
Npts95=sum(mat_sorted(:,3)<0.95);%Npts in 95%HPD set 

mat_95=mat_sorted(1:Npts95,:);

LB_x_HPD=min(mat_95(:,1));
UB_x_HPD=max(mat_95(:,1));
 
end 
