% Computes the quantile of a rv X given some given probability p
% when -X follows the EV mixture F, 
% where F = sum_k omega_k * EV(mu_k,sigma_k)

% Input: (omega,mu,sigma) and p
% Output: delta = the quantile 
% i.e. delta: F_X(delta)=p

% (1) Denote L = - X
% (2) Find d' s.t. F_L(d')=1-p
% (3) Take delta = -d'
function delta = comp_quantile_minus_evmix(omega, mu, sigma, p, delta0)
fun = @(pm)cdf_evmix_val(omega, mu, sigma, pm, 1-p); %pm=parameter 
%options = optimset('TolX',10^-3);
d_p = fzero(fun,delta0);
delta = -d_p;
end 