% Consider a mixture of univariate EV densities 
% The code computes the truncated integral of at some given value, val.
% where F = sum_k omega_k * EV(mu_k,sigma)

% Input: (omega,mu,sigma) 
% mu is 1 by m 
% omega is m by 1
% sigma is m by 1
%        val = the value for truncation 
% Output:  e = the truncated integral at val 
% i.e. int_val^infty zdF(z) 

function e = comp_trnct_int_evmix(omega,mu,sigma,val)
b = (val-mu')./sigma +double(eulergamma);
e = omega'* ( mu' - val * exp( -exp(-b) ) + sigma .* modify_expint_exp_minus(b) );
end 