% Computes the truncated integral of a rv X at some given value
% when -X follows the mixture of EV F
% where F = sum_k omega_k * EV(mu_k,sigma_k)

% Input: (omega,mu,sigma) 
%        val = the value for truncation 
% Output:  e = the truncated integral at val 
% i.e. e = int_val^infty xdF_X(x) 

% (1) Denote L = - X
% (2) Compute int_(-val)^infty l dF_L(l)
% (3) This actually equals e_X
function e = comp_trnct_int_minus_evmix(omega,mu,sigma,val)
e = comp_trnct_int_evmix(omega,mu,sigma,-val);
end 