% t = 0,1,...,T
% v = 0,1,...,T-1
% a = 0,1,...,T-1
% In our notation, the state space of x=(t, v,a) is 1+1+2^2+3^2+...+T^2
% x=1 corresponds to (0,0,0) 
% x=2 corresponds to (1,0,0)

% For each t, (t,v,a) has t^2 potentials values 
% We want a function that maps (t,v,a) into x 

% Input (t,v,a) and T
% Output x=x(t,v,a) 
% clear;t=11;v=0;a=10;
function x=find_x(t,v,a)
if     t==0
    x=1; %(0,0,0) is considered as x=1
elseif t==1
    x=2; %(1,0,0) is considered as x=2
elseif t>1
    % For each t=2,...,T, there are t^2 values of (v,a) 
    % Create a matrix of indcies
    mat=reshape(1:1:t^2,t,t);
    where_given_t=mat(a+1,v+1);

    %new_mat=reshape(mat,t^2,1 );
    %val=10*v+a;
    %where_given_t=find( (new_mat==val) );%within the "t" th group, this is the rank

    % There are 1+ 1+ 2^2 + 3^2 + ...(t-1)^2 elements before the "t" th group 
    x=1+1+sum( (2:1:t-1).^2 ) ...
        +where_given_t;
        
end 


end 







