% Generate all possible history of states after (1,0,0)==2
function [state_probability,state]=state_probability(T,ccp,eta,H)

x_history_matrix=nan((4^T-1)/3-1,T  );
x_history_matrix(:,1)=2;
d_history_matrix=nan((4^T-1)/3-1,T-1  );


first_row=1;
for last_period=2:T
% All possible sequence of decisions   
N=4^(last_period-1);
d_history=permn([0 1 2 3],last_period-1) ;
% Corresponding state history
x_history=zeros(N,last_period-1);
v=zeros(N,1);a=zeros(N,1);
for time=1:last_period-1    
    v=v+( d_history(:,time)==1 | d_history(:,time)==3 );
    a=a+( d_history(:,time)==2 | d_history(:,time)==3 );
        for i=1:N
        x_history(i,time)=find_x(time+1,v(i),a(i));
        end 
end 
last_row=first_row+N-1;

x_history_matrix(first_row:last_row,2:size(x_history,2)+1)=x_history;
d_history_matrix(first_row:last_row,1:size(x_history,2))=d_history;

first_row=last_row+1;
end 

x_tva=construct_x_tva(T);
p_history_matrix=ones((4^T-1)/3-1,T-1  );

first_row=1;
for last_period=2:T
% All possible sequence of decisions   
N=4^(last_period-1);
last_row=first_row+N-1;

d_history=d_history_matrix(first_row:last_row,1:last_period-1);
x_history=x_history_matrix(first_row:last_row,1:last_period);
p_history=zeros(N,last_period-1);

for time=1:last_period-1
    for i=1:N
        x=x_history(i,time);
        d=d_history(i,time);      
        v=x_tva(x, 3 );
        a=x_tva(x, 4 );                
        pi_w=costruct_pi_w(time,v,a,d,eta,H);
        p_history(i,time)=ccp(x,d+1)*(1-pi_w);
    end 
end 

p_history_matrix(first_row:last_row,1:size(p_history,2))=p_history;

first_row=last_row+1;
end 

% still has some repetitions 
state_prob=zeros(length(x_history_matrix),2);
state_prob(:,2)=prod(p_history_matrix,2);
%exp( sum(log(p_history_matrix),2) );


ind= sum(~isnan(x_history_matrix),2) ;

for j=1:length(x_history_matrix)
state_prob(j,1)=x_history_matrix(j,ind(j));
end 

state_prob=sortrows(state_prob,1);

X=state_prob;
[a,~,c] = unique(X(:,1));
state_probability = [ 1;1; accumarray(c,X(:,2))];
K=1+T*(T+1)*(2*T+1)/6;
state=(1:K)';




end 

