function [m,para_trans]=run_jump_step(para_trans,m,...
    prior_WEIGHT,prior_LOCATION,prior_SCALE,dir_hyp,Am_,Amlogp_,...
    n_decision,...
    J,K,G,beta,S,include_u,theta_fixed,u_fixed,Z_mat_Jp2toD,max_m)

WEIGHT_mu        = prior_WEIGHT(2,:)';
WEIGHT_s_comp    = prior_WEIGHT(3,:)';

LOCATION_mu      = prior_LOCATION(2,:)';
LOCATION_s_comp  = prior_LOCATION(3,:)';

SCALE_mu         = prior_SCALE(2,:)';
SCALE_s_comp     = prior_SCALE(3,:)';

% 1 Current parameter value with unnnormalized weights
    [now_para_trans_unnor,gamma_now,mu_now,s_comp_now,s_common_now,theta_Jp2toD_now]...
    =para_trans_to_para_trans_unnor(para_trans,dir_hyp,J,m,K,S,include_u,theta_fixed,u_fixed,Z_mat_Jp2toD,G,beta);

% 2 Propose m^*: wp 0.5, m'=m-1 wp 0.5, m'=m+1 
    %if m==1 
    %    prop_m=m+1;
    %elseif m==max_m
    %    prop_m=m-1;
    %else
        prop_m=m+2*(rand<0.5)-1; % prop_m=m+1 wp 0.5 and =m-1 wp 0.5
    %end 
   
% 3 Propose chi_{1:m^*} 
%if prop_m~=0 && prop_m~=max_m+1
if prop_m~=0     
    if prop_m==m+1 % m=1,2,3,...
        %  map = \bar_{chi_{m+1}} =  argmax_{ chi_{m+1}  } posterior of chi_{1:m+1} given the value of chi_{1:m} fixed 
        [map,hessian] = comp_map_cov_mp1(now_para_trans_unnor,prior_WEIGHT,prior_LOCATION,prior_SCALE,dir_hyp,m,G,beta,u_fixed,Z_mat_Jp2toD,n_decision,include_u,zeros(K,1));
        [shape_gamma,scale_gamma,mean_mu_vec,cov_mu_vec,mean_s_comp,cov_s_comp]=comp_mean_var(map,hessian,J);
        % Proposed chi_{m+1}
        gamma_added  = gamrnd(shape_gamma, scale_gamma);
        mu_vec_added = mvnrnd(mean_mu_vec, cov_mu_vec )';
        s_comp_added = mvnrnd(mean_s_comp, cov_s_comp)';
        % Proposed chi_{1:m+1}
        gamma_new=[gamma_now;gamma_added];mu_new=[mu_now,mu_vec_added];mu_vec_new=reshape(mu_new',(m+1)*J,1);s_comp_new=[s_comp_now;s_comp_added];
        prop_para_trans_unnor=[gamma_new;mu_vec_new;s_comp_new;s_common_now;theta_Jp2toD_now];
    elseif prop_m==m-1 % m=2,3,4,... 
        % Randomply choose the index "m" 
        which_comp_to_remove = randi(m);
        % Define chi_{1:m-1} and chi_{m} 
        [gamma_new,mu_vec_new,s_comp_new,...
            gamma_removed,mu_vec_removed,s_comp_removed]=remove_chi_m(which_comp_to_remove,gamma_now,mu_now,s_comp_now);
        % Proposed chi_{1:m-1}
        prop_para_trans_unnor=[gamma_new;mu_vec_new;s_comp_new;s_common_now;theta_Jp2toD_now];
        % map = \bar_{chi_{m}} =  argmax_{ chi_{m}  } posterior of chi_{1:m} given the value of chi_{1:m-1} fixed 
        [map,hessian] = comp_map_cov_mp1(prop_para_trans_unnor,prior_WEIGHT,prior_LOCATION,prior_SCALE,dir_hyp,m-1,G,beta,u_fixed,Z_mat_Jp2toD,n_decision,include_u,zeros(K,1));
        [shape_gamma,scale_gamma,mean_mu_vec,cov_mu_vec,mean_s_comp,cov_s_comp] = comp_mean_var(map,hessian,J);
    end 
    
% 4  Compute acceptance prob    
% If accepted, m=prop_m  and cur_para_trans=prop_para_trans
% If not,      m=m       and cur_para_trans=para_trans_sim(Nsim,:)'
   
    loglik_prop   = comp_loglik_unnor_new(prop_para_trans_unnor,prop_m,n_decision,G,beta,u_fixed,Z_mat_Jp2toD,include_u,zeros(K,1));    
    loglik_now    = comp_loglik_unnor_new(now_para_trans_unnor ,m     ,n_decision,G,beta,u_fixed,Z_mat_Jp2toD,include_u,zeros(K,1));
    LogLikDiff    = loglik_prop-loglik_now   ;
    LogPriorDiffm = - Am_*( prop_m *(log(prop_m))^Amlogp_ - m*(log(m))^Amlogp_ );
  
    if prop_m==m+1
      % logP( chi_{m+1} | m+1 )
      Logprior_chi_mp1  = prior_gamma(gamma_added, dir_hyp/(m+1)) + normalDistGrad_mix(mu_vec_added,WEIGHT_mu,LOCATION_mu,SCALE_mu)   + normalDistGrad_mix(s_comp_added,WEIGHT_s_comp,LOCATION_s_comp,SCALE_s_comp);
      % logP( gamma_{1:m} | m+1 ) - logP( gamma_{1:m} | m )  
      LogPriorDiffGamma = sum( lngampdf(gamma_now,dir_hyp./(m+1),1)) - sum( lngampdf(gamma_now,dir_hyp./m,1) );
      % logP( chi_{m+1} | chi_{1:m}, m+1 ) (approx)
      LogRetrospPrior   = lngampdf(gamma_added,shape_gamma,scale_gamma)+lnnormpdf(mu_vec_added,mean_mu_vec,cov_mu_vec) + lnnormpdf(s_comp_added,mean_s_comp,cov_s_comp);
      prob              = exp( LogLikDiff + LogPriorDiffm + Logprior_chi_mp1 + LogPriorDiffGamma  - LogRetrospPrior );
    elseif prop_m==m-1
      % logP( chi_{m} | m )
      Logprior_chi_m    = prior_gamma(gamma_removed, dir_hyp/m)   + normalDistGrad_mix(mu_vec_removed,WEIGHT_mu,LOCATION_mu,SCALE_mu) + normalDistGrad_mix(s_comp_removed,WEIGHT_s_comp,LOCATION_s_comp,SCALE_s_comp);
      % logP(gamma_{1:m-1} | m-1 ) - logP(gamma_{1:m-1} | m )  
      LogPriorDiffGamma = sum(lngampdf(gamma_new,dir_hyp./(m-1),1))-  sum(lngampdf(gamma_new,dir_hyp./m,1));
      % logP( chi_{m} | chi_{1:m-1}, m) (approx)
      LogRetrospPrior   = lngampdf(gamma_removed,shape_gamma,scale_gamma)+lnnormpdf(mu_vec_removed,mean_mu_vec,cov_mu_vec) + lnnormpdf(s_comp_removed,mean_s_comp,cov_s_comp);
      prob              = exp( LogLikDiff + LogPriorDiffm - Logprior_chi_m   + LogPriorDiffGamma  + LogRetrospPrior );
    end 
    prob=min(1,prob);

% 5 Accept-Reject step 
    if rand<prob % then accept
        m=prop_m;para_trans_unnor=prop_para_trans_unnor;
    else
        m=m;     para_trans_unnor=now_para_trans_unnor;
    end 
elseif prop_m==0
        m=1;     para_trans_unnor=now_para_trans_unnor;
%elseif prop_m==m+1
%        m=max_m; para_trans_unnor=now_para_trans_unnor;
end 
% 6 Updated current parameter value 
    para_trans=[gamma_to_alpha(para_trans_unnor(1:m));para_trans_unnor(m+1:end)];
end 

