% (1) Apply the NK DP 
% (2) If the NK does not end after n_iter_nk iterations, switch to the regular
%     value function iterations until the error < 10^-4 or hits the maximum
%     # of iterations = n_iter

function [Q,v_mat,ev_mat,ccp] = solveDP_evmix_NK(u_mat,G,mu,sigma,omega,beta,n_iter_nk,n_iter,Q_init) 
[K,Nd]=size(u_mat);
% Create an index to re-arrange the G matrix 
xStart = 1; dx = K; N = Nd; x = xStart + (0:N-1)*dx;
yStart=x';  dy=ones(Nd,1);  y = yStart + bsxfun(@times,(0:K-1),dy);
ind=reshape(y,Nd*K,1);
GG=G(ind,:);
mat2=permute( reshape(GG,Nd,K,K), [1 3 2]);
%Initialize 
Q=Q_init;
    for counter_VI=1:10
        Q1 =comp_tau(Q,u_mat,G,mu,sigma,omega,beta);
        error = norm(Q1-Q);   
        Q=Q1;
        if error < 1 %10^-1
            break;
        end 
%     formatSpec = 'Initial Value Function Iteration %d\n Error %8.6f\n';
%     fprintf(formatSpec,counter_VI, error);       
    end    
n_iter_nk=1000;n_iter=1000;
if counter_VI==10
for counter_NK=1:n_iter_nk 
    % 1. Compute tau(Q)
    tau_Q =comp_tau(Q,u_mat,G,mu,sigma,omega,beta);                     % K by 1
    % 2. compute p (K by Nd)
    v_mat = u_mat +beta * reshape(G*Q,K,Nd);    
    p = comp_ccp(v_mat,mu,sigma,omega)';
    % 3. Compute derivative 
    mat1=reshape(p,Nd,1,K);
    result=bsxfun(@times, mat1, mat2);
    deriv = beta*reshape(sum(result),K,K)' ;%K by K
    Y = eye(K) - deriv;
    %Y = Y +0.0000001*eye(K); % jitter added 12/24/19
    Y = Y +0.001*eye(K); % jitter added 5/3/23
   
    % 4. Update Q1    
    if beta>0
    Q1=Q-Y\(Q-tau_Q);
    elseif beta==0
    Q1=tau_Q;
    end 
    error = norm(Q1-Q); 
    Q=Q1;
    if error < 10^-1
        break;
    end 
% formatSpec = 'NK-Iteration %d\n Error %8.6f\n';
% fprintf(formatSpec,counter_NK, error);
end
% If the NK does not end after n_iter_nk iterations, then switch to the regular
%     value function iterations 
if counter_NK == n_iter_nk
    for counter_VI=1:n_iter 
        Q1 =comp_tau(Q,u_mat,G,mu,sigma,omega,beta);
        error = norm(Q1-Q);   
        Q=Q1;
        if error < 10^-1
            break;
        end 
%     formatSpec = 'Value Function Iteration %d\n Error %8.6f\n';
%     fprintf(formatSpec,counter_VI, error);       
    end     
end 
end
v_mat = u_mat + beta * reshape(G*Q,K,Nd);                         % K by Nd
ev_mat = reshape(G*Q,K,Nd);                                   % K by Nd
ccp = comp_ccp(v_mat,mu,sigma,omega);
end 
 

