% Transform (omega,mu_vec,sigma,sigma_common,theta(J+2:D)) 
% to (alpha,mu_vec,s,s_common,theta(J+2:D))
% para =[omega;mu_vec;sigma;sigma_common;theta(J+2:D)] m+Jm+m+1+S by 1 if include_u==1
% para =[omega;mu_vec;sigma;sigma_common]              m+Jm+m+1   by 1 if include_u==0
% omega             m by 1
% mu_vec          J*m by 1 =[mu(j=1,:)';...;mu(j=J,:)']
% sigma        m by 1
% sigma_common 1 by 1
% theta(J+2:D)      S by 1
% para_trans =[alpha;mu_vec;s;s_common;theta(J+2:D)] m-1+Jm+m+1+S by 1 if include_u==1
% para_trans =[alpha;mu_vec;s;s_common]              m-1+Jm+m+1   by 1 if include_u==0
% alpha       (m-1) by 1
% mu_vec       J*m  by 1 
% s            m    by 1
% s_common        1    by 1
% theta(J+2:D) S    by 1  

% If m=1, no alpha
function para_trans=trans_var(para,m,J,S,include_u)
% 1. Unpack para 
Nomega         = m;
Nmu_vec        = J*m;
Nsigma         = m;
Nsigma_common  = 1;
Ntheta_Jp2toD  = S;
S1             = Nomega;
S2             = Nomega+Nmu_vec;
S3             = Nomega+Nmu_vec+Nsigma;
S4             = Nomega+Nmu_vec+Nsigma+Nsigma_common;
S5             = Nomega+Nmu_vec+Nsigma+Nsigma_common+Ntheta_Jp2toD;
omega          = para(1:S1);
mu_vec         = para(1+S1:S2);
sigma          = para(1+S2:S3);
sigma_common   = para(1+S3:S4);
if include_u==1
theta_Jp2toD   = para(1+S4:S5);
end 

% 2. Transform omega to alpha
if m>1
    alpha = zeros(m-1,1);
    for k=1:m-1
        alpha(k) = log(omega(k))-log(1-sum(omega(1:m-1)));
    end 
end 

% 3. Transform (sigma, sigma_common) to (s_comp, s_common)
s_common = log(sigma_common);
s_comp   = log(sigma)-s_common;

% 4. Combine
Nalpha                = m-1;
Ns_comp               = m;
Ns_common             = 1;
N1                    = Nalpha;
N2                    = Nalpha+Nmu_vec;
N3                    = Nalpha+Nmu_vec+Ns_comp;
N4                    = Nalpha+Nmu_vec+Ns_comp+Ns_common;
N5                    = Nalpha+Nmu_vec+Ns_comp+Ns_common+Ntheta_Jp2toD;
if m>1
para_trans(1:N1,1)    = alpha;
end 
para_trans(1+N1:N2,1) = mu_vec;
para_trans(1+N2:N3,1) = s_comp;
para_trans(1+N3:N4,1) = s_common;
if include_u==1
para_trans(1+N4:N5,1) = theta_Jp2toD;
end 




end 