
para_trans_sim=data(2:end,:);size(para_trans_sim)

m_sim = data(1,:);
Nmcmc_iter=length(m_sim);

max_m=max(m_sim);
Npara_trans = (1:max_m)-1+J*(1:max_m)+(1:max_m)+1+S*include_u;

% pmf of m
pi_m=exp(  -Am_.*(1:max_m).*(log(1:max_m).^Amlogp_)  );

t=tabulate(m_sim);
post_pmf=t(:,3)/100;
diff=length(pi_m)-length(post_pmf);
if diff~=0
    post_pmf=[post_pmf; zeros(diff,1)];
end 



% Compute identified set
para_sim=zeros(max_m+J*max_m+max_m+1+S*include_u,Nmcmc_iter);  % Store para_trans
s_sim=zeros(1,Nmcmc_iter);
omegamu_sim=zeros(J,Nmcmc_iter);
theta_sim=zeros(D,Nmcmc_iter);

omega_sim=zeros(max_m,Nmcmc_iter);
mu_sim=zeros(max_m,Nmcmc_iter);
sigma_sim=zeros(max_m,Nmcmc_iter);
tic;
for mcmc_iter=2:Nmcmc_iter
%mcmc_iter    
[~,mu,~,~,~,omega,sigma,~]=compute_stats(para_trans_sim(1:Npara_trans(m_sim(mcmc_iter)),mcmc_iter),theta_fixed,J,m_sim(mcmc_iter),K,S,include_u,u_fixed,Z_mat_Jp2toD,G,beta);
[s_sim(mcmc_iter),omegamu_sim(:,mcmc_iter)] =comp_s_omegamu_rust(omega,mu , sigma );
omega_sim(1:m_sim(mcmc_iter),mcmc_iter)=omega;
mu_sim(1:m_sim(mcmc_iter),mcmc_iter)=mu;
sigma_sim(1:m_sim(mcmc_iter),mcmc_iter)=sigma;
theta_sim(1,mcmc_iter)=s_sim(mcmc_iter)*(theta_fixed(1:J) - omegamu_sim(:,mcmc_iter));
theta_sim(2,mcmc_iter)=s_sim(mcmc_iter)*theta_fixed(J+1);
end 
toc;

% Trace on m
figure
subplot(2,3,1)
plot(1:Nmcmc_iter, m_sim,'.');
xlim([1 Nmcmc_iter])
xlabel('iterations');ylabel('m')

%figure
subplot(2,3,2)
scatter(1:max_m,pi_m/sum(pi_m),35,'s' )
hold on
scatter(1:max_m,post_pmf,35,'o', 'MarkerFaceColor', 'r')
legend('prior','posterior','Location',[0.5,0.8127,0.1375,0.0631], 'LineWidth', 3);
ylabel('Pr(m)');xlabel('m');ylim([0 0.5])

% Trace plot for model parameters
subplot(2,3,3)
plot(1:Nmcmc_iter,omegamu_sim);title('\omega^T \mu');xlim([1 Nmcmc_iter]);ylim([-20 0])
subplot(2,3,4)
plot(1:Nmcmc_iter,s_sim);title('s');ylim([0 15]);xlim([1 Nmcmc_iter])
subplot(2,3,5)
plot(1:Nmcmc_iter,theta_sim(1,:));title('\theta_0');ylim([0 50]);xlim([1 Nmcmc_iter])
subplot(2,3,6)
plot(1:Nmcmc_iter,theta_sim(2,:));title('\theta_1');xlim([1 Nmcmc_iter])

dt=csvread('all_x_y.csv');all_x=dt(1:211);all_y=dt(212:211*2);
% Identified set
figure
subplot(1,2,1)
scatter(theta_sim(1,:),theta_sim(2,:),2.5,'blue');
hold on; plot(theta1_true,theta2_true,'r*','LineWidth', 10);
hold on;ch_ind = convhull(all_x, all_y);
dx=dt(211*2+1);
dy=dt(end);
plot(all_x(ch_ind)*dx,all_y(ch_ind)*dy,'LineWidth',5+0,'Color','black')
ylim([-25*10^-3 0]);xlim([-5 40]);xlabel('\theta_0');ylabel('\theta_1');

% 3D identified set. Z-axis = time
subplot(1,2,2)
scatter3(theta_sim(1,:),theta_sim(2,:),1:1:size(para_trans_sim,2),2.5,'MarkerFaceColor',[0 .75 .75] )
hold on;ch_ind = convhull(all_x, all_y);dx=dt(211*2+1);dy=dt(end);plot(all_x(ch_ind)*dx,all_y(ch_ind)*dy,'LineWidth',5,'Color','black' )
ylim([-25*10^-3 0]);xlim([-5 40]);xlabel('\theta_0');ylabel('\theta_1');zlabel('Iterations')


figure
scatter(theta_sim(1,:),theta_sim(2,:),10.5+10,'blue');
hold on; plot(theta1_true,theta2_true,'r*','LineWidth', 10);
hold on;ch_ind = convhull(all_x, all_y);
dx=dt(211*2+1);
dy=dt(end);
plot(all_x(ch_ind)*dx,all_y(ch_ind)*dy,'LineWidth',5+3,'Color','black')
ylim([-25*10^-3 0]);xlim([-5 40]);xlabel('\theta_0');ylabel('\theta_1');
x0=100;y0=100;width=375*(8/10);375;height=300*(8/10);300;
set(gcf,'position',[x0,y0,width,height])



% 2. Counterfactual analysis 
slice=1;100;

mu_sim_sliced=mu_sim(:,1:slice:end);
sigma_sim_sliced=sigma_sim(:,1:slice:end);
omega_sim_sliced=omega_sim(:,1:slice:end);
m_sim_sliced=m_sim(1:slice:end);

Nmcmc_iter_sliced=length(m_sim_sliced);

beta = 0.999;  K=90;
theta0_true = 5.0727; theta1_true = -0.002293;u1  = theta0_true+theta1_true*(1:K)'; u2 = zeros(K,1); u=[u1,u2];

pi_1=0.3919; pi_2=0.5953; 
pi_1_cf=0.6; pi_2_cf=0.3; 
[G1,G2]=transition_mat(pi_1,pi_2,K);G=[G1;G2];
[G1_cf,G2_cf]=transition_mat(pi_1_cf,pi_2_cf,K);G_cf=[G1_cf;G2_cf];

actual_ccp =zeros(K,Nmcmc_iter_sliced);
cf_ccp     =zeros(K,Nmcmc_iter_sliced);
for mcmc_iter=2:Nmcmc_iter_sliced
    mcmc_iter
    [~,~,~,ccp1]=solveDP_evmix_NK(u_mat_true,G, mu_sim_sliced(1:m_sim_sliced(mcmc_iter),mcmc_iter)', sigma_sim_sliced(1:m_sim_sliced(mcmc_iter),mcmc_iter), omega_sim_sliced(1:m_sim_sliced(mcmc_iter),mcmc_iter),beta,10000,10000,zeros(K,1)) ;
    actual_ccp(:,mcmc_iter)=ccp1(:,2);
    [~,~,~,ccp2]=solveDP_evmix_NK(u_mat_true,G_cf, mu_sim_sliced(1:m_sim_sliced(mcmc_iter),mcmc_iter)', sigma_sim_sliced(1:m_sim_sliced(mcmc_iter),mcmc_iter), omega_sim_sliced(1:m_sim_sliced(mcmc_iter),mcmc_iter),beta,10000,10000,zeros(K,1)) ;
    cf_ccp(:,mcmc_iter)=ccp2(:,2);
    mcmc_iter
end

Xset = [5 30 60 80 85 90]';


figure
for i=1:6
    subplot(3,2,i)
    h=histfit(actual_ccp(Xset(i),2:end),15,'kernel');delete(h(1));h(2).LineStyle = '-';h(2).Color='blue';
    hold on; 
    h=histfit(cf_ccp(Xset(i),2:end),15,'kernel');delete(h(1));h(2).LineStyle = ':';h(2).Color='blue';
    title(['x= ' num2str(Xset(i)) ]); legend('actual','cf');
end 
sgtitle('Post. for Actual and CF CCPs ')


figure
for state=1:K
max_val = max( cf_ccp(state,2:end) );
min_val = min( cf_ccp(state,2:end) );
line([state state], [min_val max_val]);
end
xlabel('x');ylabel('cf CCPs');title('Identified Set Projections for CF CCPs')
ylim([0 0.9])






