% 1. Read data from the simulator 
Nsim=10;
Njdt_iter=30000;
burnin=0;slice=1;
Npara_trans = (1:max_m)-1+J*(1:max_m)+(1:max_m)+1+S*include_u;


filename=['varm_JDTJ' num2str(J), 'Nsim' num2str(Nsim),'beta' num2str(beta),'.csv'];
data=csvread(filename);size(data)


%data=reshape(data,Njdt_iter,max_m-1+J*max_m+max_m+1+S*include_u+1)';
data=data(:,burnin+1:slice:end);size(data)
m_sim = data(1,:);figure;plot(1:length(m_sim),m_sim,'*')

data=sortrows(data')';
Njdt_iter=size(data,2);
m_sim = data(1,:);%para_trans_sim=data(2:end,:);

max_m = max(m_sim)




% 1. Simulate from the prior 
Nsim_prior = 30000;
m_prior=zeros(1,Nsim_prior);
%para_trans_prior=zeros(m-1+J*m+m+1+S,Nsim_prior);
para_trans_prior=zeros(max_m-1+J*max_m+max_m+1+S*include_u,Nsim_prior);  
 
mpriorPMF = exp(-Am_.*(1:max_m).*(log(1:max_m).^Amlogp_));
mpriorPMF = mpriorPMF./sum(mpriorPMF);
mpriorCDF = cumsum(mpriorPMF);

for sim=1:Nsim_prior
m_prior(sim) = find  (rand <= mpriorCDF,1);
para_trans_prior(1:Npara_trans(m_prior(sim)),sim)= prior_para_trans_given_m(prior_WEIGHT,prior_LOCATION,prior_SCALE,dir_hyp,...
    J,m_prior(sim),S,include_u);
end

data_prior=[m_prior;para_trans_prior];
data_prior=sortrows(data_prior')';
tab_prior=tabulate(m_prior);m_count_prior=tab_prior(:,2);

Nm_prior(1)=m_count_prior(1);
para_trans_prior_m={};
para_trans_prior_m{1}=data_prior(2:Npara_trans(1)+1,1:Nm_prior(1));

for m_ind=2:max_m
Nm_prior(m_ind)=Nm_prior(m_ind-1)+m_count_prior(m_ind);
para_trans_prior_m{m_ind}=data_prior(2:Npara_trans(m_ind)+1,Nm_prior(m_ind-1)+1:Nm_prior(m_ind) );
end 


% Compare 
tab       = tabulate(m_sim);prob=tab(:,3)/100;m_count=tab(:,2);
tab_prior = tabulate(m_prior);prob_prior=tab_prior(:,3)/100;

figure
plot(1:max_m,prob,'.','MarkerSize',15)
hold on 
plot(1:max_m,mpriorPMF,'square','MarkerSize',15)
%hold on 
%plot(1:max_m,prob_prior,'square','MarkerSize',15)
legend('simulator','prior')
ylim([0 1])




% For each m=1,...,max_m, compare data (simulator) with prior 

Nm(1)=m_count(1);
para_trans_sim_m={};
para_trans_sim_m{1}=data(2:Npara_trans(1)+1,1:Nm(1));

for m_ind=2:max_m
Nm(m_ind)=Nm(m_ind-1)+m_count(m_ind);
para_trans_sim_m{m_ind}=data(2:Npara_trans(m_ind)+1,Nm(m_ind-1)+1:Nm(m_ind) );
end 

for m=1:max_m
% Prior given m   
para_trans_prior=para_trans_prior_m{m};
    
alpha_prior         = zeros(m-1,m_count_prior(m));
mu_prior            = zeros(J,m,m_count_prior(m));
s_comp_prior        = zeros(m,m_count_prior(m));
s_common_prior      = zeros(1,m_count_prior(m));
theta_Jp2toD_prior  = zeros(S,m_count_prior(m));
ccp_prior           = zeros(K,J+1,m_count_prior(m));

tic;
for sim_prior=1:m_count_prior(m)
[alpha_prior(:,sim_prior),mu_prior(:,:,sim_prior),s_comp_prior(:,sim_prior),s_common_prior(:,sim_prior),theta_Jp2toD_prior(:,sim_prior),...
~,~,ccp_prior(:,:,sim_prior)]...
=compute_stats(para_trans_prior(:,sim_prior),theta_fixed,J,m,K,S,include_u,u_fixed,Z_mat_Jp2toD,G,beta);
end 
toc;
    
    
% Simulator given m     
para_trans_sim=para_trans_sim_m{m};
    
alpha_sim         = zeros(m-1,m_count(m));
mu_sim            = zeros(J,m,m_count(m));
s_comp_sim        = zeros(m,m_count(m));
s_common_sim      = zeros(1,m_count(m));
theta_Jp2toD_sim  = zeros(S,m_count(m));
ccp_sim           = zeros(K,J+1,m_count(m));

tic;
for jdt_iter=1:m_count(m)
[alpha_sim(:,jdt_iter),mu_sim(:,:,jdt_iter),s_comp_sim(:,jdt_iter),s_common_sim(:,jdt_iter),theta_Jp2toD_sim(:,jdt_iter),...
~,~,ccp_sim(:,:,jdt_iter)]...
=compute_stats(para_trans_sim(:,jdt_iter),theta_fixed,J,m,K,S,include_u,u_fixed,Z_mat_Jp2toD,G,beta);
end 
toc;



% INDIVIDUAL PARAMETERS 

if m>1
    
figure
for k=1:m-1
subplot(1,m-1,k)
data1=alpha_prior(k,:);
data2=alpha_sim(k,:);
[f,xi] = ksdensity( data1 ); plot(xi,f,'Linewidth',4);
hold on 
[f,xi] = ksdensity( data2 ); plot(xi,f,'Linewidth',4);
legend('prior','simulator');
[h,p,ci,stats] = ttest2(data1,data2);
title(['Equal mean test p-value ', num2str(p)]);

end 
suptitle(['alpha, m = ', num2str(m)]);

end 


ind=1;
figure
for j=1:J
    for k=1:m
subplot(m,J,ind)
data1=reshape(mu_prior(j,k,:),m_count_prior(m),1) ;
data2=reshape(mu_sim(j,k,:),m_count(m),1);
[f,xi] = ksdensity( data1 ); plot(xi,f,'Linewidth',4);
hold on 
[f,xi] = ksdensity( data2 ); plot(xi,f,'Linewidth',4);
[h,p,ci,stats] = ttest2(data1,data2);
title(['Equal mean test p-value ', num2str(p)]);

grid = [-0.05:0.001:0.05];
pdf = normpdf(grid,prior_LOCATION(2,1),prior_SCALE(2,1));
hold on 
plot(grid,pdf,'Linewidth',4)
xlim([-0.05 0.05])
legend('prior','simulator','prior pdf');
ind=ind+1;
    end 
end 
suptitle(['mu, m = ', num2str(m)]);

figure
for k=1:m
subplot(1,m,k)
data1=s_comp_prior(k,:) ;
data2=s_comp_sim(k,:) ;
[f,xi] = ksdensity(data1); plot(xi,f,'Linewidth',4);
hold on 
[f,xi] = ksdensity(data2); plot(xi,f,'Linewidth',4);
[h,p,ci,stats] = ttest2(data1,data2);

grid = [-0.05:0.001:0.05];
pdf = normpdf(grid,prior_LOCATION(3,1),prior_SCALE(3,1));
hold on 
plot(grid,pdf,'Linewidth',4)
xlim([-0.05 0.05])
legend('prior','simulator','prior pdf');

title(['Equal mean test p-value ', num2str(p)]);
end 
suptitle(['s-comp, m = ', num2str(m)]);

figure
data1=s_common_prior ;
data2=s_common_sim ;
[f,xi] = ksdensity(data1); plot(xi,f,'Linewidth',4);
hold on 
[f,xi] = ksdensity(data2); plot(xi,f,'Linewidth',4);
[h,p,ci,stats] = ttest2(data1,data2);
grid = [-0.05:0.001:0.05];
pdf = normpdf(grid,prior_LOCATION(4,1),prior_SCALE(4,1));
hold on 
plot(grid,pdf,'Linewidth',4)
title(['s-common  Equal mean test p-value ', num2str(p)]);
%title(['s-common, m = ', num2str(m)]);
xlim([-0.05 0.05])
legend('prior','simulator','prior pdf');



if include_u==1
figure
for s=1:S
subplot(1,S,s)
data1=theta_Jp2toD_prior(s,:);
data2=theta_Jp2toD_sim(s,:);
[f,xi] = ksdensity(data1); plot(xi,f,'Linewidth',4);
hold on 
[f,xi] = ksdensity(data2); plot(xi,f,'Linewidth',4);
[h,p,ci,stats] = ttest2(data1,data2);
title(['Equal mean test p-value ', num2str(p)]);
grid = [-0.05:0.001:0.05];
pdf = normpdf(grid,prior_LOCATION(5,1),prior_SCALE(5,1));
hold on 
plot(grid,pdf,'Linewidth',4)
xlim([-0.05 0.05])
legend('prior','simulator','prior pdf');
end 
suptitle('utility thetas treated as paras')

end 


end 




