% INPUT 
% v_mat  is K by Nd
% mu     is J by m 
% sigma  is m by 1
% omega  is m by 1
% OUTPUT 
% A      is m by K 
% a      is m by K

function [A,a] = comp_as(v_mat,mu,sigma,omega)
K=size(v_mat,1);Nd=size(v_mat,2);J=Nd-1;m=size(omega,1);
v=v_mat(:,2:end);
v0=v_mat(:,1);
E = ( reshape(repmat(reshape(v,J*K,1),1,m)',K*m,J)  + repmat(mu',K,1) )./repmat(sigma,K,J);
B = exp( E - max(E,[],2) );
A= reshape( max(E,[],2) + log(sum(B,2)), m,K);
a= repmat(v0',m,1)./repmat(sigma,1,K) +repmat(double(eulergamma),m,K)-A ;
end 






