% INPUT 
% v_mat       is      K by Nd
% mu          is      J by m 
% sigma       is      m by 1
% omega       is      m by 1
% OUTPUT 
% ccp         is      K by Nd 
% ccp_mixcomp is (Nd*K) by m 

function [ccp,ccp_mixcomp] = comp_ccp(v_mat,mu,sigma,omega)
K=size(v_mat,1);Nd=size(v_mat,2);J=Nd-1;m=size(omega,1);
v=v_mat(:,2:end);%v0=v_mat(:,1);
[A,a]  = comp_as(v_mat,mu,sigma,omega);
ccp_k0 = exp(-exp(-a));  % m by K p(d=0|x, k)
%ccp_0  = omega'*ccp_k0;  % 1 by K p(d=0|x)
E1 = ( reshape(repmat(reshape(v,J*K,1),1,m)',K*m,J)  + repmat(mu',K,1) )./repmat(sigma,K,J);
E2=reshape(repmat(reshape(       A,        m*K,1),J,1),K*m,J);
E3=reshape(repmat(reshape( 1-exp(-exp(-a)),m*K,1),J,1),K*m,J);
D=exp(E1-E2).*E3;
ccp_mixcomp = [ccp_k0';reshape( reshape(D,m*K*J,1), m,J*K)'];% Nd*K by m. [p(d=0|x,k);p(d=1|x,k); ...; p(d=Nd|x,k)]


% Normalization (will make a very little difference)
%newmat=reshape( reshape(ccp_mixcomp,K,m*(J+1)), K,J+1,m);% (sum(newmat,2)==1)
%newmat=newmat./sum(newmat,2) ;%normalize
%ccp_mixcomp=reshape(newmat,K*(J+1),m);


ccp = reshape( sum(ccp_mixcomp.*repmat(omega',Nd*K,1),2), K,Nd); % K by Nd ( sum(ccp,2)==1 )
% Normalization (same)
%ccp=ccp./sum(ccp,2);

 






