function [grad_D_omega,grad_D_mu,grad_D_sigma,grad_D_u0,grad_D_ud]...
    =comp_grad_D_para(omega,mu,sigma,v_mat,beta,G,...
                      grad_A_omega,grad_A_mu,grad_A_sigma,grad_A_u0,grad_A_ud,...
                      grad_Q_omega,grad_Q_mu,grad_Q_sigma,grad_Q_u0,grad_Q_ud)

K=size(v_mat,1);Nd=size(v_mat,2);J=Nd-1;m=size(omega,1);
v=v_mat(:,2:end);

Gmat=G((K+1):end,:);newG=reshape( Gmat', K,K,J);newG=permute(newG,[2 1 3]);


delta=K*J+1;base=1:delta:1+(J-1)*delta;plus=K*J*J;ind=reshape( plus*(0:1:(K-1))'+repmat(base,K,1)+( (1:J:1+(K-1)*J)-1 )',1,J*K);mat=zeros(K*K*J*J,1);mat(ind)=1;
% Create indicators
ind_mu=reshape( kron( reshape(eye(m),1,m*m),kron(eye(J),ones(K,1))),K*J,J*m,m);
ind_sigma=reshape(kron(reshape(eye(m),1,m*m),ones(J*K,1)),K*J,m,m);
ind_ud=repmat(reshape(permute(reshape(reshape(mat,J,K*K*J)', J,K*J,K),[2 1 3]),K*J,K*J),1,1,m);

% Convert sigma to a KJ by L by m array i.e. m KJbyL matrices. 
% For each k=1:m, the KJbyL matrix = ones(KJ,L)*1/sigma(k)
inv_sigma_3d_Jm=repmat(reshape(1./sigma,1,1,m),K*J,J*m);%L=Jm for mu 
inv_sigma_3d_JK=repmat(reshape(1./sigma,1,1,m),K*J,J*K);%L=JK for ud

% Derivatives of "D" wrt (a)mu,(b)sigma,and (c)ud have second parts that we define here
% (a) wrt mu
part2_grad_D_mu    = ind_mu.*inv_sigma_3d_Jm;
% (b) wrt mu
part2_grad_D_sigma =-ind_sigma.*reshape(( repmat(reshape(v,K*J,1),1,m*m) + kron(kron(mu,ones(K,1)),ones(1,m)) ).*kron(( sigma.^(-2))',ones(J*K,m)),K*J,m,m);
% (c) wrt ud
part2_grad_D_ud    = ind_ud.*inv_sigma_3d_JK;

% 1. grad_D_omega
if m>1
grad_D_omega=comp_part1_grad_D_para_origin(m-1,grad_Q_omega,grad_A_omega,newG,sigma,m,K,J,beta);
elseif m==1
grad_D_omega=[];    
end 
% 2. grad_D_mu
grad_D_mu=comp_part1_grad_D_para_origin(J*m,grad_Q_mu,grad_A_mu,newG,sigma,m,K,J,beta)...
              +part2_grad_D_mu;
% 3. grad_D_sigma
grad_D_sigma=comp_part1_grad_D_para_origin(m,grad_Q_sigma,grad_A_sigma,newG,sigma,m,K,J,beta)...
                 +part2_grad_D_sigma;
% 4. grad_D_u0
grad_D_u0=comp_part1_grad_D_para_origin(K,grad_Q_u0,grad_A_u0,newG,sigma,m,K,J,beta);
% 5. grad_D_ud
grad_D_ud=comp_part1_grad_D_para_origin(J*K,grad_Q_ud,grad_A_ud,newG,sigma,m,K,J,beta)...
              +part2_grad_D_ud;
end 
 