function [grad_P_omega,grad_P_mu,grad_P_sigma,...
          grad_P_u0,grad_P_ud,...
          grad_condP_omega,grad_condP_mu,grad_condP_sigma,...
          grad_condP_u0,grad_condP_ud]...
    =comp_grad_P_para(omega,mu,sigma,a,A,ccp_mixcomp,v_mat,beta,G,...
grad_Q_omega,grad_Q_mu,grad_Q_sigma,grad_Q_u0,grad_Q_ud)
 
K=size(v_mat,1);Nd=size(v_mat,2);J=Nd-1;m=size(omega,1);
v=v_mat(:,2:end);
[D,F,E1]=comp_DF(v,mu,sigma,A,G,J,K,m);

if m>1 
[grad_A_omega, grad_a_omega, grad_A_mu, grad_a_mu,...
 grad_A_sigma, grad_a_sigma, grad_A_u0, grad_a_u0, grad_A_ud, grad_a_ud]...
=comp_grad_as_para(omega,sigma,v_mat,beta,G,D,F,E1,...
grad_Q_omega,grad_Q_mu,grad_Q_sigma,grad_Q_u0,grad_Q_ud);

[grad_D_omega,grad_D_mu,grad_D_sigma,grad_D_u0,grad_D_ud]...
=comp_grad_D_para(omega,mu,sigma,v_mat,beta,G,...
                      grad_A_omega,grad_A_mu,grad_A_sigma,grad_A_u0,grad_A_ud,...
                      grad_Q_omega,grad_Q_mu,grad_Q_sigma,grad_Q_u0,grad_Q_ud);
elseif m==1
[~, ~, grad_A_mu, grad_a_mu,...
 grad_A_sigma, grad_a_sigma, grad_A_u0, grad_a_u0, grad_A_ud, grad_a_ud]...
=comp_grad_as_para(omega,sigma,v_mat,beta,G,D,F,E1,...
[],grad_Q_mu,grad_Q_sigma,grad_Q_u0,grad_Q_ud);   
[~,grad_D_mu,grad_D_sigma,grad_D_u0,grad_D_ud]...
=comp_grad_D_para(omega,mu,sigma,v_mat,beta,G,...
                      [],grad_A_mu,grad_A_sigma,grad_A_u0,grad_A_ud,...
                      [],grad_Q_mu,grad_Q_sigma,grad_Q_u0,grad_Q_ud);

end 
%[~,ccp_mixcomp] = comp_ccp(v_mat,mu,sigma,omega);

% 1. grad_condP_omega
if m>1
grad_condP_omega = comp_grad_condP_para_origin(m-1,grad_D_omega,grad_a_omega,K,J,m,ccp_mixcomp,a,D);
elseif m==1
grad_condP_omega=[];    
end 
% 2. grad_condP_mu
grad_condP_mu    = comp_grad_condP_para_origin(J*m,grad_D_mu,grad_a_mu,K,J,m,ccp_mixcomp,a,D);
% 3. grad_condP_sigma
grad_condP_sigma = comp_grad_condP_para_origin(m,grad_D_sigma,grad_a_sigma,K,J,m,ccp_mixcomp,a,D);
% 4. grad_condP_u0
grad_condP_u0    = comp_grad_condP_para_origin(K,grad_D_u0,grad_a_u0,K,J,m,ccp_mixcomp,a,D);
% 5. grad_condP_uj
grad_condP_ud    = comp_grad_condP_para_origin(K*J,grad_D_ud,grad_a_ud,K,J,m,ccp_mixcomp,a,D);


% 1. grad_P_omega
if m>1
grad_P_omega = ccp_mixcomp(:,1:m-1)-ccp_mixcomp(:,end)+sum(grad_condP_omega.*reshape(omega,1,1,m),3);
elseif m==1
grad_P_omega=[];    
end 
% 2. grad_P_mu
grad_P_mu    = sum(grad_condP_mu.*reshape(omega,1,1,m),3);
% 3. grad_P_sigma
grad_P_sigma = sum(grad_condP_sigma.*reshape(omega,1,1,m),3);
% 4. grad_P_u0
grad_P_u0    = sum(grad_condP_u0.*reshape(omega,1,1,m),3);
% 5. grad_P_ud
grad_P_ud    = sum(grad_condP_ud.*reshape(omega,1,1,m),3);
end 