% mixture of normals

% m= # mixtures
% Omega=(omega_1,...,omega_m)';
% Mu=(mu_1,...,mu_m)';
% Sigma=(sigma_1,...,sigma_m)';
% X=(X_1,...,X_d)';
% f(x_i) = sum_k omega_k p(x_i|mu_k,sigma_k); i=1,...,d
% f(X) = prod_i f(x_i)

function [lpdf,glpdf,g2lpdf] = normalDistGrad_mix(X,Omega,Mu,Sigma)
Z= (X'-Mu)./Sigma; %m by d 
max_elm = max(0.5*Z.^2);% max element inside of exponent
lpdf=-sum(max_elm)+sum(log(sum(Omega.*(1./(sqrt(2*pi)*Sigma )).*exp(-0.5*Z.^2+max_elm))));

%lpdf=sum(  log( Omega'* ( (1./(sqrt(2*pi)*Sigma )).*exp(-0.5*Z.^2) )   )  );




if nargout>1
%f_i = sum(Omega.*(1./(sqrt(2*pi)*Sigma)).*exp(-0.5*Z.^2)); %f(x_1),...,f(x_d)
f_i = sum(Omega.*(1./(sqrt(2*pi)*Sigma)).*exp(-0.5*Z.^2+max_elm)); %f(x_1),...,f(x_d)
%num =-sum(Omega.*(1./(sqrt(2*pi)*Sigma)).*exp(-0.5*Z.^2).*(Z./Sigma));%numerator in derivatives
num =-sum(Omega.*(1./(sqrt(2*pi)*Sigma)).*exp(-0.5*Z.^2+max_elm).*(Z./Sigma));%numerator in derivatives
glpdf=(num./f_i)';

grad_num=sum( Omega.*( 1./(sqrt(2*pi)*Sigma) ).*exp(-0.5*Z.^2).*(1./(Sigma.^2)).*( Z.^2-1   )     );
self_deriv = (grad_num.*f_i - num.*num)./(f_i.^2);
%g2lpdf=self_deriv.*eye(length(X));
g2lpdf=self_deriv'; % dont report cross derivatives -- they are zeros 

end 

end 

% example
%{
%m=2;d=1;
%Omega=[0.5;0.5];Mu=[0;1.5];Sigma=[0.2;1];
%Omega=[1/3;1/3;1/3];Mu=[1.5;-20;80];Sigma=[5;15;100];
Omega=[0.1;0.9];Mu=[-50;400];Sigma=[50;200];

X_grid=-100:1:1000;n=length(X_grid);lpdf=zeros(1,n);glpdf=zeros(1,n);
for i=1:n
    [lpdf(i),glpdf(i)] = normalDistGrad_mix(X_grid(i),Omega,Mu,Sigma);
end 
figure;plot(X_grid,exp(lpdf))
%hold on; plot(X_grid,glpdf);legend('lpdf','glpdf')

Mu = [-6 ; 0 ];Sigma = cat(3,0.1^2,0.1^2); Omega = [0.3 0.7];                     
gm = gmdistribution(Mu,Sigma,Omega);
grid =-10:0.1:10;
for j=1:length(grid)
gmPDF(j) = pdf(gm,grid(j));
end 
figure;plot(grid,gmPDF)


%}



