% epsilon ~ \sum_{k=1}^m omega_k EV(mu_k,sigma_k)
% omega_mu = omega'*mu
% X = omega_mu - epsilon 
% -X ~ \sum_{k=1}^m omega_k EV(mu_k-omega_mu,sigma_k)
% E(-X) = 0


function [s,omega_mu] = comp_s_omegamu_rust(omega, mu, sigma)

omega_mu=mu*omega;
mu_minus_x = mu - omega_mu;% location parameter for -X
median_x = comp_quantile_minus_evmix(omega, mu_minus_x, sigma, 0.5, 0.9);
e_x = comp_trnct_int_minus_evmix(omega,mu_minus_x,sigma,median_x);
s = log(2)/e_x;
end 