% Prior on (alpha_1,..,alpha_m) so that 
% (omega_1,...,omega_m) ~ \sim Dir(a_1,...,a_m)

% f_alpha(alpha) = f_omega(g(alpha)) * | grad_g(alpha)_alpha |

% output: log pdf and its derivatives wrt alpha_l's
%{
clear
m=3;
omega=[0.2;0.1;0.7];
% Transform omega to alpha
alpha = zeros(m-1,1);
for k=1:m-1
    alpha(k) = log(omega(k))-log(1-sum(omega(1:m-1)));
end
dir_hyp=ones(m,1);

%}

function [lpdf,glpdf]=prior_alpha(alpha,dir_hyp)
m=length(alpha)+1;
% 1. Jacobian matrix 
max_alpha=max(alpha);
lambda = alpha - max_alpha;

const = ( exp(-max_alpha) + sum(exp(lambda)) )^2;  % C'
grad_omega_alpha=( const )^(-1)*(...
- exp(lambda'+lambda )...
+ exp(lambda'+lambda).*eye(m-1)...
+diag( ( exp(-max_alpha)+sum(exp(lambda))-exp(lambda') ).*exp(lambda')));

% 2. Compute omega
omega = zeros(m,1);
for k=1:m-1
    omega(k)=exp(alpha(k)-max_alpha)/( exp(-max_alpha) + sum(exp(alpha-max_alpha)) );  
end 
omega(m) = 1 -sum(omega(1:m-1));

% 3. pdf
lpdf=log( dir_pdf(omega,dir_hyp) )+log( det(grad_omega_alpha) );
% 4. gradient 
% second derivative of omega wrt alpha
mat=zeros(m-1,m-1,m-1);
for l=1:m-1
temp=diag( exp( lambda(l)+lambda ) );
temp(:,l)= -exp( lambda(l)+lambda );
temp(l,:)= -exp( lambda(l)+lambda  );
temp(l,l)=exp(lambda(l))*(  exp(-max_alpha) +  sum(exp(lambda([1:l-1 l+1:end]))) );
%exp(lambda(l) - max_alpha)+sum(exp(lambda));
mat(:,:,l)=temp;
end 
part1=mat*const;
part2=...
( const*grad_omega_alpha*2*sqrt(const) ).*reshape(exp(lambda),1,1,m-1);


grad3d=(1/const^2)*(part1-part2);

inv_grad_omega_alpha=grad_omega_alpha\eye(m-1);

%inv(grad_omega_alpha);

glpdf=zeros(m-1,1);
for l=1:m-1
    glpdf(l)=...
   (  ( dir_hyp(1:end-1) - 1)./omega(1:end-1) - (dir_hyp(end) -1)/omega(end)  )'* ...
   grad_omega_alpha(:,l)...
  + trace( inv_grad_omega_alpha*grad3d(:,:,l)  );
end 



end 