% Nd is the total number of decisions = J+1
% K is the num of states
% u_mat is K by Nd
% G = [G0;G1;...GJ] is (K*Nd) by K
% ccp is K by Nd
% v_mat is K by Nd
% ev_mat is K by Nd
% Q is K by 1
function [ccp, ev_mat,v_mat,emax] = solveDP_dyn_logit(u_mat,G,beta,n_iter)
K=size(u_mat,1);
Nd=size(u_mat,2);
%Initialize Q
Q = zeros(K,1);  
% K by 1
for counter=1:1:n_iter 
v_mat = u_mat +beta * reshape(G*Q,K,Nd);   
max_v = max(v_mat,[],2) ;  
Q1=max_v+log( sum( exp( v_mat - max_v ),2) );
error=norm(Q-Q1);
Q=Q1;
if error < 10^-8
    break;
end 
formatSpec = 'Iteration %d\n Error %8.6f\n';
fprintf(formatSpec,counter, error);
end 

v_mat = u_mat + beta * reshape(G*Q,K,Nd);                         % K by Nd
ev_mat = reshape(G*Q,K,Nd);   
emax=Q;
ccp=zeros(K,Nd);
for d=1:Nd
    %ccp(:,d) = 1./sum( exp( v_mat-v_mat(:,d) ),2 );
    ccp(:,d) = exp(v_mat(:,d)-max_v)./sum( exp( v_mat-max_v ),2 );

end 



end 