% Transform  (alpha, mu_vec, s_comp,     s_common,     theta(J+2:D)) 
% to         (omega, mu_vec, sigma, sigma_common, theta(J+2:D)) 
% para_trans =[alpha;mu_vec;s_comp;s_common;theta(J+2:D)] m-1+Jm+m+1+S by 1 if include_u==1
% para_trans =[alpha;mu_vec;s_comp;s_common]              m-1+Jm+m+1   by 1 if include_u==0
% alpha       (m-1) by 1
% mu_vec       J*m  by 1 =[mu(j=1,:)';...;mu(j=J,:)']
% s            m    by 1
% s_common     1    by 1
% theta(J+2:D) S    by 1 
% para =[omega;mu_vec;sigma;sima_all;theta(J+2:D)] m+Jm+m+1+S by 1 if include_u==1
% para =[omega;mu_vec;sigma;sima_all]              m+Jm+m+1   by 1 if include_u==0
% omega             m by 1
% mu_vec          J*m by 1 
% sigma        m by 1
% sigma_common      1 by 1
% theta(J+2:D)      S by 1

% If m=1, no alpha
function para=trans_inv_var(para_trans,m,J,S,include_u)
% 1. Unpack the para_trans 
Nalpha        = m-1;
Nmu_vec       = J*m;
Ns_comp       = m;
Ns_common     = 1;
Ntheta_Jp2toD = S;
N1            = Nalpha;
N2            = Nalpha+Nmu_vec;
N3            = Nalpha+Nmu_vec+Ns_comp;
N4            = Nalpha+Nmu_vec+Ns_comp+Ns_common;
N5            = Nalpha+Nmu_vec+Ns_comp+Ns_common+Ntheta_Jp2toD;

if m>1
alpha         = para_trans(1:N1);
end 
mu_vec        = para_trans(1+N1:N2);
s_comp        = para_trans(1+N2:N3);
s_common      = para_trans(1+N3:N4);
if include_u==1
theta_Jp2toD  = para_trans(1+N4:N5);
end 

% 2. Transform alpha to omega
if m>1
    max_alpha = max(alpha);
    omega = zeros(m,1);
    for k=1:m-1
        omega(k)=exp(alpha(k)-max_alpha)/( exp(-max_alpha) + sum(exp(alpha-max_alpha)) );  
    end
omega(m) = 1 -sum(omega(1:m-1));    
elseif m==1
omega=1;
end 


% 3. Transform s to sigma 
sigma          = exp( s_comp+s_common );
sigma_common   = exp( s_common );

% 4. Define para  
Nomega              = m;
Nsigma              = m;
Nsigma_common       = 1;
S1                  = Nomega;
S2                  = Nomega+Nmu_vec;
S3                  = Nomega+Nmu_vec+Nsigma;
S4                  = Nomega+Nmu_vec+Nsigma+Nsigma_common;
S5                  = Nomega+Nmu_vec+Nsigma+Nsigma_common+Ntheta_Jp2toD;
para(1:S1,1)        = omega;
para(1+S1:S2,1)     = mu_vec;
para(1+S2:S3,1)     = sigma;
para(1+S3:S4,1)     = sigma_common;
if include_u==1
para(1+S4:S5,1)     = theta_Jp2toD;
end 
  

  
end 